
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         cpg_parser_parse
#define yylex           cpg_parser_lex
#define yyerror         cpg_parser_error
#define yylval          cpg_parser_lval
#define yychar          cpg_parser_char
#define yydebug         cpg_parser_debug
#define yynerrs         cpg_parser_nerrs
#define yylloc          cpg_parser_lloc

/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "cpg-parser.y"


#include "cpg-parser-context.h"
#include "cpg-parser.h"

static void cpg_parser_error (YYLTYPE *locp, CpgParserContext *context, char *s);
int cpg_parser_lex(YYSTYPE *lvalp, YYLTYPE *llocp, void *scanner);

#define scanner (cpg_parser_context_get_scanner (context))

#define append_array(array, type, value, code)				\
{									\
	GArray *arret = array;						\
	type theval = value;						\
									\
	if (arret == NULL)						\
	{								\
		arret = g_array_new (FALSE, FALSE, sizeof (type));	\
	}								\
									\
	g_array_append_val (arret, theval);				\
									\
	code;								\
}

#define errb								\
	if (cpg_parser_context_get_error (context) != NULL)		\
	{								\
		YYERROR;						\
	}

static CpgFunctionPolynomialPiece *create_polynomial_piece (gdouble  start,
                                                            gdouble  end,
                                                            GArray  *coefficients);

static CpgFunctionArgument *create_function_argument (CpgEmbeddedString *name,
                                                      CpgEmbeddedString *default_value,
                                                      gboolean           is_explicit);



/* Line 189 of yacc.c  */
#line 123 "cpg-parser.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     T_KEY_IN = 258,
     T_KEY_INTEGRATED = 259,
     T_KEY_ONCE = 260,
     T_KEY_OUT = 261,
     T_KEY_STATE = 262,
     T_KEY_LINK = 263,
     T_KEY_NETWORK = 264,
     T_KEY_FUNCTIONS = 265,
     T_KEY_INTERFACE = 266,
     T_KEY_IMPORT = 267,
     T_KEY_INPUT_FILE = 268,
     T_KEY_POLYNOMIAL = 269,
     T_KEY_FROM = 270,
     T_KEY_TO = 271,
     T_KEY_PIECE = 272,
     T_KEY_TEMPLATES = 273,
     T_KEY_TEMPLATES_ROOT = 274,
     T_KEY_DEFINES = 275,
     T_KEY_INTEGRATOR = 276,
     T_KEY_GROUP = 277,
     T_KEY_LAYOUT = 278,
     T_KEY_AT = 279,
     T_KEY_OF = 280,
     T_KEY_ON = 281,
     T_KEY_INCLUDE = 282,
     T_KEY_DEBUG = 283,
     T_KEY_DEBUG_PRINT = 284,
     T_KEY_PROPERTY = 285,
     T_KEY_DELETE = 286,
     T_KEY_ACTION = 287,
     T_KEY_ROOT = 288,
     T_KEY_CHILDREN = 289,
     T_KEY_PARENT = 290,
     T_KEY_FIRST = 291,
     T_KEY_LAST = 292,
     T_KEY_SUBSET = 293,
     T_KEY_SIBLINGS = 294,
     T_KEY_STATES = 295,
     T_KEY_LINKS = 296,
     T_KEY_COUNT = 297,
     T_KEY_SELF = 298,
     T_KEY_CONTEXT = 299,
     T_KEY_AS = 300,
     T_KEY_EACH = 301,
     T_KEY_PROXY = 302,
     T_KEY_BIDIRECTIONAL = 303,
     T_KEY_OBJECTS = 304,
     T_KEY_GROUPS = 305,
     T_KEY_IMPORTS = 306,
     T_KEY_PROPERTIES = 307,
     T_KEY_ACTIONS = 308,
     T_KEY_IF = 309,
     T_KEY_SETTINGS = 310,
     T_KEY_NAME = 311,
     T_KEY_DESCENDANTS = 312,
     T_KEY_ANCESTORS = 313,
     T_KEY_UNIQUE = 314,
     T_KEY_IS_EMPTY = 315,
     T_KEY_REMOVE = 316,
     T_KEY_NO_SELF = 317,
     T_KEY_PROBABILITY = 318,
     T_KEY_FROM_SET = 319,
     T_KEY_TYPE = 320,
     T_KEY_PARSE = 321,
     T_KEY_HAS_FLAG = 322,
     T_KEY_HAS_TEMPLATE = 323,
     T_KEY_HAS_TAG = 324,
     T_KEY_TAG = 325,
     T_KEY_ALL = 326,
     T_KEY_APPLY = 327,
     T_KEY_UNAPPLY = 328,
     T_KEY_BEFORE_APPLY = 329,
     T_KEY_AFTER_APPLY = 330,
     T_KEY_BEFORE_UNAPPLY = 331,
     T_KEY_AFTER_UNAPPLY = 332,
     T_KEY_REVERSE = 333,
     T_KEY_WITH = 334,
     T_KEY_OBJECT = 335,
     T_STRING_REDUCE_BEGIN = 336,
     T_STRING_REDUCE_END = 337,
     T_STRING_MAP_BEGIN = 338,
     T_STRING_MAP_END = 339,
     T_CONDITION_BEGIN = 340,
     T_CONDITION_END = 341,
     T_KEY_LEFT_OF = 342,
     T_KEY_RIGHT_OF = 343,
     T_KEY_BELOW = 344,
     T_KEY_ABOVE = 345,
     T_DOUBLE = 346,
     T_INTEGER = 347,
     T_IDENTIFIER = 348,
     T_STRING = 349,
     T_ANNOTATION_START = 350,
     T_ANNOTATION_END = 351,
     T_EOF = 352,
     T_STRING_BEGIN = 353,
     T_STRING_END = 354,
     T_REGEX_BEGIN = 355,
     T_REGEX_END = 356,
     T_EQUATION_BEGIN = 357,
     T_EQUATION_END = 358,
     T_INDIRECTION_BEGIN = 359,
     T_INDIRECTION_END = 360,
     T_INDIRECTION_EMBEDDING_BEGIN = 361,
     T_INDIRECTION_EMEDDING_END = 362,
     T_START_DOCUMENT = 363,
     T_START_SELECTOR = 364,
     T_START_GROUP = 365,
     T_START_LINK = 366,
     T_START_STATE = 367
   };
#endif
/* Tokens.  */
#define T_KEY_IN 258
#define T_KEY_INTEGRATED 259
#define T_KEY_ONCE 260
#define T_KEY_OUT 261
#define T_KEY_STATE 262
#define T_KEY_LINK 263
#define T_KEY_NETWORK 264
#define T_KEY_FUNCTIONS 265
#define T_KEY_INTERFACE 266
#define T_KEY_IMPORT 267
#define T_KEY_INPUT_FILE 268
#define T_KEY_POLYNOMIAL 269
#define T_KEY_FROM 270
#define T_KEY_TO 271
#define T_KEY_PIECE 272
#define T_KEY_TEMPLATES 273
#define T_KEY_TEMPLATES_ROOT 274
#define T_KEY_DEFINES 275
#define T_KEY_INTEGRATOR 276
#define T_KEY_GROUP 277
#define T_KEY_LAYOUT 278
#define T_KEY_AT 279
#define T_KEY_OF 280
#define T_KEY_ON 281
#define T_KEY_INCLUDE 282
#define T_KEY_DEBUG 283
#define T_KEY_DEBUG_PRINT 284
#define T_KEY_PROPERTY 285
#define T_KEY_DELETE 286
#define T_KEY_ACTION 287
#define T_KEY_ROOT 288
#define T_KEY_CHILDREN 289
#define T_KEY_PARENT 290
#define T_KEY_FIRST 291
#define T_KEY_LAST 292
#define T_KEY_SUBSET 293
#define T_KEY_SIBLINGS 294
#define T_KEY_STATES 295
#define T_KEY_LINKS 296
#define T_KEY_COUNT 297
#define T_KEY_SELF 298
#define T_KEY_CONTEXT 299
#define T_KEY_AS 300
#define T_KEY_EACH 301
#define T_KEY_PROXY 302
#define T_KEY_BIDIRECTIONAL 303
#define T_KEY_OBJECTS 304
#define T_KEY_GROUPS 305
#define T_KEY_IMPORTS 306
#define T_KEY_PROPERTIES 307
#define T_KEY_ACTIONS 308
#define T_KEY_IF 309
#define T_KEY_SETTINGS 310
#define T_KEY_NAME 311
#define T_KEY_DESCENDANTS 312
#define T_KEY_ANCESTORS 313
#define T_KEY_UNIQUE 314
#define T_KEY_IS_EMPTY 315
#define T_KEY_REMOVE 316
#define T_KEY_NO_SELF 317
#define T_KEY_PROBABILITY 318
#define T_KEY_FROM_SET 319
#define T_KEY_TYPE 320
#define T_KEY_PARSE 321
#define T_KEY_HAS_FLAG 322
#define T_KEY_HAS_TEMPLATE 323
#define T_KEY_HAS_TAG 324
#define T_KEY_TAG 325
#define T_KEY_ALL 326
#define T_KEY_APPLY 327
#define T_KEY_UNAPPLY 328
#define T_KEY_BEFORE_APPLY 329
#define T_KEY_AFTER_APPLY 330
#define T_KEY_BEFORE_UNAPPLY 331
#define T_KEY_AFTER_UNAPPLY 332
#define T_KEY_REVERSE 333
#define T_KEY_WITH 334
#define T_KEY_OBJECT 335
#define T_STRING_REDUCE_BEGIN 336
#define T_STRING_REDUCE_END 337
#define T_STRING_MAP_BEGIN 338
#define T_STRING_MAP_END 339
#define T_CONDITION_BEGIN 340
#define T_CONDITION_END 341
#define T_KEY_LEFT_OF 342
#define T_KEY_RIGHT_OF 343
#define T_KEY_BELOW 344
#define T_KEY_ABOVE 345
#define T_DOUBLE 346
#define T_INTEGER 347
#define T_IDENTIFIER 348
#define T_STRING 349
#define T_ANNOTATION_START 350
#define T_ANNOTATION_END 351
#define T_EOF 352
#define T_STRING_BEGIN 353
#define T_STRING_END 354
#define T_REGEX_BEGIN 355
#define T_REGEX_END 356
#define T_EQUATION_BEGIN 357
#define T_EQUATION_END 358
#define T_INDIRECTION_BEGIN 359
#define T_INDIRECTION_END 360
#define T_INDIRECTION_EMBEDDING_BEGIN 361
#define T_INDIRECTION_EMEDDING_END 362
#define T_START_DOCUMENT 363
#define T_START_SELECTOR 364
#define T_START_GROUP 365
#define T_START_LINK 366
#define T_START_STATE 367




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 193 "cpg-parser.y"

	gchar *id;
	CpgProperty *property;
	gdouble numf;
	gint num;
	GSList *list;
	GArray *array;
	CpgFunctionPolynomialPiece *piece;
	CpgFunctionArgument *argument;
	gpointer object;
	CpgSelector *selector;
	CpgEmbeddedString *string;
	CpgAttribute *attribute;

	struct
	{
		gint parent;
		gint idx;
	} ref;

	struct
	{
		CpgPropertyFlags add;
		CpgPropertyFlags remove;
	} flags;

	struct
	{
		CpgEmbeddedString *name;
		CpgEmbeddedString *count;
		CpgEmbeddedString *unexpanded;
	} multiassign;



/* Line 214 of yacc.c  */
#line 419 "cpg-parser.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 444 "cpg-parser.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  68
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2700

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  129
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  236
/* YYNRULES -- Number of rules.  */
#define YYNRULES  481
/* YYNRULES -- Number of states.  */
#define YYNSTATES  757

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   367

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   128,
     119,   120,     2,   125,   117,   124,   123,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   118,     2,
     127,   115,     2,   116,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   121,     2,   122,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   113,   126,   114,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     7,    11,    14,    17,    20,    21,
      24,    26,    28,    30,    32,    34,    36,    38,    40,    42,
      44,    46,    48,    50,    52,    53,    59,    61,    65,    66,
      74,    75,    82,    84,    86,    88,    90,    92,    94,    96,
      97,   102,   104,   106,   108,   110,   115,   118,   123,   126,
     128,   130,   132,   134,   135,   141,   142,   145,   149,   151,
     153,   154,   160,   161,   164,   165,   172,   176,   181,   183,
     184,   190,   191,   194,   195,   202,   203,   210,   212,   214,
     216,   218,   220,   222,   224,   225,   231,   232,   235,   238,
     242,   246,   249,   251,   252,   254,   255,   257,   258,   267,
     268,   277,   281,   282,   285,   290,   292,   294,   296,   297,
     303,   304,   307,   308,   318,   319,   328,   329,   338,   340,
     342,   344,   348,   350,   352,   356,   360,   365,   367,   371,
     378,   382,   387,   392,   394,   398,   400,   404,   406,   411,
     415,   420,   422,   424,   426,   428,   430,   432,   434,   436,
     438,   442,   443,   446,   450,   453,   457,   462,   465,   468,
     469,   471,   472,   482,   483,   492,   493,   501,   502,   511,
     512,   521,   522,   531,   532,   542,   543,   545,   546,   548,
     549,   553,   554,   564,   566,   568,   570,   571,   577,   578,
     581,   582,   589,   590,   593,   595,   603,   605,   607,   611,
     615,   617,   621,   625,   627,   631,   633,   635,   639,   641,
     645,   647,   649,   651,   653,   654,   661,   662,   668,   669,
     672,   674,   676,   678,   680,   682,   684,   685,   692,   694,
     696,   698,   699,   705,   706,   709,   710,   717,   718,   721,
     728,   730,   732,   733,   739,   741,   743,   745,   746,   753,
     755,   756,   762,   763,   766,   768,   770,   772,   774,   777,
     783,   787,   789,   790,   794,   800,   806,   813,   817,   818,
     820,   822,   825,   829,   832,   833,   835,   837,   839,   841,
     843,   849,   851,   853,   855,   857,   859,   860,   865,   869,
     870,   874,   876,   878,   880,   882,   886,   887,   892,   894,
     896,   898,   900,   903,   905,   906,   909,   911,   913,   915,
     917,   919,   921,   923,   925,   927,   929,   931,   933,   935,
     937,   939,   941,   943,   945,   947,   949,   951,   953,   955,
     957,   959,   961,   963,   965,   967,   969,   971,   973,   975,
     977,   981,   983,   988,   990,   992,   994,   996,   998,  1000,
    1004,  1006,  1008,  1009,  1014,  1016,  1018,  1020,  1022,  1024,
    1026,  1028,  1032,  1034,  1035,  1041,  1046,  1050,  1052,  1053,
    1059,  1063,  1065,  1067,  1069,  1071,  1077,  1078,  1085,  1086,
    1091,  1093,  1095,  1097,  1099,  1101,  1104,  1105,  1108,  1112,
    1115,  1117,  1119,  1126,  1132,  1134,  1136,  1138,  1140,  1141,
    1147,  1148,  1151,  1154,  1156,  1158,  1160,  1162,  1164,  1166,
    1168,  1170,  1172,  1174,  1176,  1178,  1180,  1182,  1184,  1186,
    1188,  1190,  1191,  1194,  1195,  1200,  1201,  1202,  1203,  1214,
    1215,  1220,  1224,  1226,  1229,  1231,  1232,  1236,  1238,  1239,
    1244,  1245,  1250,  1252,  1254,  1255,  1258,  1259,  1264,  1265,
    1266,  1267,  1278,  1280,  1282,  1284,  1286,  1287,  1290,  1291,
    1296,  1298,  1300,  1302,  1304,  1305,  1308,  1309,  1314,  1315,
    1320,  1323,  1326,  1329,  1331,  1333,  1334,  1340,  1343,  1344,
    1347,  1348
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     130,     0,    -1,    -1,   108,   131,    -1,   109,   276,    97,
      -1,   110,   241,    -1,   111,   251,    -1,   112,   237,    -1,
      -1,   131,   132,    -1,   138,    -1,   171,    -1,   182,    -1,
     204,    -1,   209,    -1,   180,    -1,   222,    -1,   304,    -1,
     161,    -1,   305,    -1,   154,    -1,   361,    -1,   363,    -1,
     140,    -1,    -1,   200,   113,   133,   131,   114,    -1,    97,
      -1,   200,    27,   321,    -1,    -1,   200,    66,   321,   113,
     137,   158,   114,    -1,    -1,   200,     9,   113,   139,   149,
     114,    -1,   159,    -1,   358,    -1,   135,    -1,   136,    -1,
     146,    -1,   134,    -1,   141,    -1,    -1,    95,   142,   323,
      96,    -1,    74,    -1,    75,    -1,    76,    -1,    77,    -1,
      72,   269,    16,   269,    -1,    72,   269,    -1,    73,   269,
      15,   269,    -1,    73,   269,    -1,   144,    -1,   145,    -1,
     256,    -1,   140,    -1,    -1,   200,   113,   148,   149,   114,
      -1,    -1,   149,   147,    -1,   252,   115,   321,    -1,   150,
      -1,   140,    -1,    -1,   200,   113,   152,   153,   114,    -1,
      -1,   153,   151,    -1,    -1,   200,    21,   113,   155,   153,
     114,    -1,   254,   115,   321,    -1,   254,   116,   115,   321,
      -1,   358,    -1,    -1,   201,   113,   157,   158,   114,    -1,
      -1,   158,   156,    -1,    -1,   200,    20,   113,   160,   158,
     114,    -1,    -1,   200,    18,   113,   162,   165,   114,    -1,
     171,    -1,   204,    -1,   209,    -1,   182,    -1,   304,    -1,
     140,    -1,   305,    -1,    -1,   200,   113,   164,   165,   114,
      -1,    -1,   165,   163,    -1,   117,   269,    -1,   166,   117,
     269,    -1,   118,   269,   166,    -1,   118,   269,    -1,   167,
      -1,    -1,   168,    -1,    -1,   252,    -1,    -1,   200,     7,
     170,   169,   113,   172,   237,   114,    -1,    -1,   200,     7,
     273,   169,   113,   173,   237,   114,    -1,   321,   115,   321,
      -1,    -1,   175,   174,    -1,    55,   113,   175,   114,    -1,
     176,    -1,   256,    -1,   140,    -1,    -1,   200,   113,   178,
     179,   114,    -1,    -1,   179,   177,    -1,    -1,   200,    13,
     321,    45,   252,   113,   181,   179,   114,    -1,    -1,   200,
      22,   170,   169,   113,   183,   241,   114,    -1,    -1,   200,
      22,   273,   169,   113,   184,   241,   114,    -1,   321,    -1,
     273,    -1,   185,    -1,   187,   117,   185,    -1,   186,    -1,
      47,    -1,    47,   119,   120,    -1,    46,   119,   120,    -1,
      46,   119,   187,   120,    -1,    48,    -1,    48,   119,   120,
      -1,    48,   119,   321,   117,   321,   120,    -1,    54,   119,
     120,    -1,    54,   119,   187,   120,    -1,    79,   119,   269,
     120,    -1,   321,    -1,   194,   117,   321,    -1,   193,    -1,
      62,   119,   120,    -1,    62,    -1,    63,   119,   321,   120,
      -1,    70,   119,   120,    -1,    70,   119,   194,   120,    -1,
     188,    -1,   189,    -1,   190,    -1,   191,    -1,   192,    -1,
     195,    -1,   196,    -1,   197,    -1,   198,    -1,   199,   117,
     198,    -1,    -1,   121,   122,    -1,   121,   199,   122,    -1,
     121,   122,    -1,   121,   199,   122,    -1,    15,   269,    16,
     269,    -1,    71,   269,    -1,    26,   269,    -1,    -1,   202,
      -1,    -1,   200,     8,   252,   203,   169,   113,   205,   251,
     114,    -1,    -1,   200,     8,   202,   169,   113,   206,   251,
     114,    -1,    -1,   200,     8,   169,   113,   207,   251,   114,
      -1,    -1,   200,     8,   273,   169,   113,   208,   251,   114,
      -1,    -1,   200,    80,   252,   169,   113,   210,   237,   114,
      -1,    -1,   200,    80,   273,   169,   113,   211,   237,   114,
      -1,    -1,   200,    14,   252,   119,   120,   113,   213,   225,
     114,    -1,    -1,   232,    -1,    -1,   230,    -1,    -1,   119,
     215,   120,    -1,    -1,   200,   252,   119,   214,   120,   216,
     115,   218,   321,    -1,   217,    -1,   212,    -1,   140,    -1,
      -1,   200,   113,   220,   221,   114,    -1,    -1,   221,   219,
      -1,    -1,   200,    10,   113,   223,   221,   114,    -1,    -1,
     225,   226,    -1,   224,    -1,    17,    15,    91,    16,    91,
     115,   227,    -1,    91,    -1,    92,    -1,   227,   117,    91,
      -1,   227,   117,    92,    -1,   252,    -1,    15,   123,   252,
      -1,    16,   123,   252,    -1,   228,    -1,   229,   117,   228,
      -1,   229,    -1,   233,    -1,   231,   117,   233,    -1,   231,
      -1,   252,   115,   321,    -1,   252,    -1,   256,    -1,   140,
      -1,   305,    -1,    -1,   200,   143,   113,   235,   237,   114,
      -1,    -1,   200,   113,   236,   237,   114,    -1,    -1,   237,
     234,    -1,   256,    -1,   171,    -1,   209,    -1,   204,    -1,
     242,    -1,   182,    -1,    -1,   200,   143,   113,   239,   241,
     114,    -1,   140,    -1,   305,    -1,   222,    -1,    -1,   200,
     113,   240,   241,   114,    -1,    -1,   241,   238,    -1,    -1,
     200,    11,   113,   243,   244,   114,    -1,    -1,   244,   246,
      -1,   200,   252,   253,   252,     3,   252,    -1,   245,    -1,
     140,    -1,    -1,   200,   113,   247,   244,   114,    -1,   262,
      -1,   256,    -1,   140,    -1,    -1,   200,   143,   113,   249,
     251,   114,    -1,   305,    -1,    -1,   200,   113,   250,   251,
     114,    -1,    -1,   251,   248,    -1,   318,    -1,   324,    -1,
     336,    -1,   115,    -1,   116,   115,    -1,   252,   117,   252,
     117,   252,    -1,   252,   117,   252,    -1,   252,    -1,    -1,
     119,   321,   120,    -1,   119,   321,   117,   321,   120,    -1,
     119,   321,   118,   321,   120,    -1,   200,   254,   253,   321,
     260,   255,    -1,   200,   254,   259,    -1,    -1,   124,    -1,
     125,    -1,   257,   261,    -1,   258,   257,   261,    -1,   126,
     258,    -1,    -1,   259,    -1,     3,    -1,     6,    -1,     4,
      -1,     5,    -1,   200,   252,   127,   115,   321,    -1,   303,
      -1,   279,    -1,   277,    -1,   263,    -1,   264,    -1,    -1,
     265,   123,   266,   264,    -1,   265,   126,   264,    -1,    -1,
     126,   268,   265,    -1,   265,    -1,   267,    -1,   269,    -1,
     263,    -1,   263,   126,   265,    -1,    -1,   263,   123,   272,
     265,    -1,   267,    -1,   271,    -1,   273,    -1,   265,    -1,
     126,   265,    -1,   275,    -1,    -1,   278,   252,    -1,   338,
      -1,    33,    -1,    19,    -1,    35,    -1,    36,    -1,    37,
      -1,    40,    -1,    41,    -1,    18,    -1,    42,    -1,    56,
      -1,    43,    -1,    64,    -1,    65,    -1,    34,    -1,    57,
      -1,    59,    -1,    58,    -1,    50,    -1,    51,    -1,    49,
      -1,    52,    -1,    53,    -1,    10,    -1,    78,    -1,   280,
      -1,   281,    -1,    15,    -1,    16,    -1,    68,    -1,   283,
      -1,   261,    -1,   321,    -1,   285,    -1,   286,   117,   285,
      -1,   286,    -1,    67,   119,   287,   120,    -1,    39,    -1,
      38,    -1,    28,    -1,    69,    -1,   289,    -1,   321,    -1,
     291,   117,   321,    -1,   291,    -1,   270,    -1,    -1,   293,
     117,   294,   270,    -1,   293,    -1,    54,    -1,    61,    -1,
      60,    -1,   321,    -1,   274,    -1,   297,    -1,   299,   117,
     297,    -1,   298,    -1,    -1,   284,   119,   301,   295,   120,
      -1,   290,   119,   292,   120,    -1,   290,   119,   120,    -1,
     290,    -1,    -1,   296,   119,   302,   299,   120,    -1,   296,
     119,   120,    -1,   296,    -1,   288,    -1,   282,    -1,   300,
      -1,   200,    12,   321,    45,   252,    -1,    -1,   200,    23,
     113,   306,   317,   114,    -1,    -1,   200,    23,   307,   314,
      -1,    87,    -1,    88,    -1,    90,    -1,    89,    -1,   308,
      -1,   309,   308,    -1,    -1,    25,   269,    -1,   269,   309,
     269,    -1,   309,   269,    -1,   117,    -1,   118,    -1,   269,
      24,   321,   312,   321,   310,    -1,    24,   321,   312,   321,
     310,    -1,   311,    -1,   313,    -1,   314,    -1,   140,    -1,
      -1,   200,   113,   316,   317,   114,    -1,    -1,   317,   315,
      -1,    93,   128,    -1,    93,    -1,    91,    -1,    92,    -1,
     324,    -1,   330,    -1,   326,    -1,   336,    -1,   318,    -1,
     320,    -1,   319,    -1,   342,    -1,   344,    -1,   356,    -1,
     354,    -1,   350,    -1,    94,    -1,   113,    -1,   114,    -1,
      -1,   323,   322,    -1,    -1,    98,   325,   323,    99,    -1,
      -1,    -1,    -1,    85,   327,   323,   117,   328,   323,   117,
     329,   323,    86,    -1,    -1,   102,   331,   323,   103,    -1,
     106,   323,   107,    -1,   332,    -1,   333,   332,    -1,    94,
      -1,    -1,    94,   335,   333,    -1,   333,    -1,    -1,   104,
     337,   334,   105,    -1,    -1,   100,   339,   323,   101,    -1,
     322,    -1,    93,    -1,    -1,   341,   340,    -1,    -1,   102,
     343,   341,   103,    -1,    -1,    -1,    -1,    85,   345,   323,
     117,   346,   323,   117,   347,   323,    86,    -1,   342,    -1,
     344,    -1,   356,    -1,    94,    -1,    -1,   349,   348,    -1,
      -1,    83,   351,   349,    84,    -1,   342,    -1,   344,    -1,
     356,    -1,    94,    -1,    -1,   353,   352,    -1,    -1,    81,
     355,   353,    82,    -1,    -1,   104,   357,   334,   105,    -1,
      29,   273,    -1,    29,   321,    -1,    29,    44,    -1,   269,
      -1,   140,    -1,    -1,   200,   113,   360,   362,   114,    -1,
      31,   359,    -1,    -1,   362,   359,    -1,    -1,   200,    31,
     113,   364,   362,   114,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   233,   233,   235,   236,   237,   238,   239,   242,   244,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   263,   262,   269,   273,   282,   279,
     291,   289,   297,   298,   299,   300,   301,   302,   303,   307,
     307,   314,   315,   316,   317,   321,   324,   329,   332,   337,
     338,   342,   343,   345,   344,   350,   352,   356,   360,   361,
     363,   362,   368,   370,   376,   374,   382,   389,   396,   398,
     397,   403,   405,   411,   409,   419,   417,   425,   426,   427,
     428,   429,   430,   431,   433,   432,   438,   440,   444,   446,
     451,   452,   456,   460,   461,   465,   466,   474,   470,   481,
     477,   492,   496,   498,   502,   509,   510,   511,   513,   512,
     518,   520,   528,   523,   538,   534,   545,   541,   555,   556,
     560,   561,   567,   571,   572,   576,   577,   585,   586,   587,
     592,   593,   601,   605,   606,   610,   614,   615,   619,   623,
     624,   629,   630,   631,   632,   633,   634,   635,   636,   640,
     641,   646,   647,   648,   652,   653,   657,   662,   666,   673,
     674,   683,   678,   690,   686,   696,   693,   703,   699,   717,
     713,   727,   723,   742,   737,   749,   750,   754,   755,   759,
     760,   771,   765,   777,   778,   779,   781,   780,   786,   788,
     794,   792,   800,   801,   806,   810,   815,   816,   817,   818,
     822,   823,   824,   828,   829,   834,   839,   840,   845,   849,
     850,   854,   855,   856,   859,   857,   863,   862,   868,   870,
     874,   875,   876,   877,   878,   879,   882,   880,   885,   886,
     887,   889,   888,   894,   896,   902,   900,   907,   909,   913,
     927,   928,   930,   929,   936,   937,   938,   941,   939,   944,
     946,   945,   951,   953,   957,   958,   959,   963,   964,   968,
     970,   972,   976,   977,   978,   988,  1001,  1017,  1033,  1034,
    1035,  1039,  1040,  1045,  1049,  1050,  1054,  1055,  1056,  1057,
    1061,  1069,  1070,  1074,  1075,  1079,  1080,  1080,  1084,  1088,
    1088,  1093,  1095,  1099,  1103,  1104,  1108,  1107,  1116,  1117,
    1123,  1127,  1128,  1132,  1136,  1136,  1141,  1145,  1146,  1147,
    1148,  1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,  1157,
    1158,  1159,  1160,  1161,  1162,  1163,  1164,  1165,  1166,  1167,
    1168,  1172,  1176,  1180,  1181,  1182,  1186,  1190,  1191,  1195,
    1196,  1201,  1205,  1214,  1215,  1216,  1217,  1221,  1225,  1226,
    1231,  1235,  1236,  1236,  1241,  1245,  1246,  1247,  1251,  1252,
    1257,  1258,  1263,  1268,  1267,  1273,  1277,  1281,  1286,  1285,
    1293,  1297,  1301,  1305,  1306,  1310,  1320,  1318,  1325,  1324,
    1330,  1331,  1332,  1333,  1337,  1338,  1342,  1343,  1347,  1350,
    1355,  1356,  1360,  1366,  1374,  1375,  1379,  1380,  1382,  1381,
    1387,  1389,  1393,  1395,  1399,  1403,  1407,  1408,  1409,  1410,
    1411,  1412,  1413,  1417,  1418,  1419,  1420,  1421,  1422,  1423,
    1424,  1427,  1429,  1433,  1433,  1439,  1448,  1455,  1439,  1467,
    1467,  1477,  1483,  1484,  1488,  1490,  1490,  1493,  1497,  1497,
    1507,  1507,  1513,  1514,  1522,  1524,  1528,  1528,  1536,  1545,
    1552,  1536,  1564,  1565,  1566,  1567,  1570,  1572,  1576,  1576,
    1584,  1585,  1586,  1587,  1590,  1592,  1596,  1596,  1604,  1604,
    1612,  1613,  1614,  1618,  1619,  1621,  1620,  1627,  1630,  1632,
    1637,  1635
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "T_KEY_IN", "T_KEY_INTEGRATED",
  "T_KEY_ONCE", "T_KEY_OUT", "T_KEY_STATE", "T_KEY_LINK", "T_KEY_NETWORK",
  "T_KEY_FUNCTIONS", "T_KEY_INTERFACE", "T_KEY_IMPORT", "T_KEY_INPUT_FILE",
  "T_KEY_POLYNOMIAL", "T_KEY_FROM", "T_KEY_TO", "T_KEY_PIECE",
  "T_KEY_TEMPLATES", "T_KEY_TEMPLATES_ROOT", "T_KEY_DEFINES",
  "T_KEY_INTEGRATOR", "T_KEY_GROUP", "T_KEY_LAYOUT", "T_KEY_AT",
  "T_KEY_OF", "T_KEY_ON", "T_KEY_INCLUDE", "T_KEY_DEBUG",
  "T_KEY_DEBUG_PRINT", "T_KEY_PROPERTY", "T_KEY_DELETE", "T_KEY_ACTION",
  "T_KEY_ROOT", "T_KEY_CHILDREN", "T_KEY_PARENT", "T_KEY_FIRST",
  "T_KEY_LAST", "T_KEY_SUBSET", "T_KEY_SIBLINGS", "T_KEY_STATES",
  "T_KEY_LINKS", "T_KEY_COUNT", "T_KEY_SELF", "T_KEY_CONTEXT", "T_KEY_AS",
  "T_KEY_EACH", "T_KEY_PROXY", "T_KEY_BIDIRECTIONAL", "T_KEY_OBJECTS",
  "T_KEY_GROUPS", "T_KEY_IMPORTS", "T_KEY_PROPERTIES", "T_KEY_ACTIONS",
  "T_KEY_IF", "T_KEY_SETTINGS", "T_KEY_NAME", "T_KEY_DESCENDANTS",
  "T_KEY_ANCESTORS", "T_KEY_UNIQUE", "T_KEY_IS_EMPTY", "T_KEY_REMOVE",
  "T_KEY_NO_SELF", "T_KEY_PROBABILITY", "T_KEY_FROM_SET", "T_KEY_TYPE",
  "T_KEY_PARSE", "T_KEY_HAS_FLAG", "T_KEY_HAS_TEMPLATE", "T_KEY_HAS_TAG",
  "T_KEY_TAG", "T_KEY_ALL", "T_KEY_APPLY", "T_KEY_UNAPPLY",
  "T_KEY_BEFORE_APPLY", "T_KEY_AFTER_APPLY", "T_KEY_BEFORE_UNAPPLY",
  "T_KEY_AFTER_UNAPPLY", "T_KEY_REVERSE", "T_KEY_WITH", "T_KEY_OBJECT",
  "T_STRING_REDUCE_BEGIN", "T_STRING_REDUCE_END", "T_STRING_MAP_BEGIN",
  "T_STRING_MAP_END", "T_CONDITION_BEGIN", "T_CONDITION_END",
  "T_KEY_LEFT_OF", "T_KEY_RIGHT_OF", "T_KEY_BELOW", "T_KEY_ABOVE",
  "T_DOUBLE", "T_INTEGER", "T_IDENTIFIER", "T_STRING",
  "T_ANNOTATION_START", "T_ANNOTATION_END", "T_EOF", "T_STRING_BEGIN",
  "T_STRING_END", "T_REGEX_BEGIN", "T_REGEX_END", "T_EQUATION_BEGIN",
  "T_EQUATION_END", "T_INDIRECTION_BEGIN", "T_INDIRECTION_END",
  "T_INDIRECTION_EMBEDDING_BEGIN", "T_INDIRECTION_EMEDDING_END",
  "T_START_DOCUMENT", "T_START_SELECTOR", "T_START_GROUP", "T_START_LINK",
  "T_START_STATE", "'{'", "'}'", "'='", "'?'", "','", "':'", "'('", "')'",
  "'['", "']'", "'.'", "'-'", "'+'", "'|'", "'<'", "'\\''", "$accept",
  "choose_parser", "document_contents", "document_item", "$@1", "eof",
  "include", "parse", "$@2", "network", "$@3", "common_scopes",
  "annotation", "$@4", "event_handler_code", "action_apply",
  "action_unapply", "actions", "network_item", "$@5", "network_contents",
  "integrator_property", "integrator_item", "$@6", "integrator_contents",
  "integrator", "$@7", "define_item", "$@8", "define_contents", "define",
  "$@9", "templates", "$@10", "template_item", "$@11", "template_contents",
  "template_list_more", "template_list_rev", "template_list", "templated",
  "identifier_or_string_or_nothing", "state", "$@12", "$@13",
  "input_file_setting", "input_file_settings_contents",
  "input_file_settings", "input_file_item", "$@14", "input_file_contents",
  "input_file", "$@15", "group", "$@16", "$@17",
  "selector_or_string_list_item", "selector_or_string_list_rev",
  "selector_or_string_list", "attribute_proxy", "attribute_each",
  "attribute_bidirectional", "attribute_if", "attribute_with",
  "string_list_rev", "string_list", "attribute_no_self",
  "attribute_probability", "attribute_tag", "attribute_contents",
  "attributes_contents", "attributes", "attributes_strict",
  "link_connect_fast", "link_connect", "link", "$@18", "$@19", "$@20",
  "$@21", "object", "$@22", "$@23", "function_polynomial", "$@24",
  "function_argument_list_or_empty",
  "function_argument_list_or_empty_impl", "function_argument_implicit",
  "function_custom", "$@25", "function_item", "$@26", "function_contents",
  "functions", "$@27", "polynomial_pieces_rev", "polynomial_pieces",
  "polynomial_piece", "double_list", "function_argument_impl",
  "function_argument_list_impl_rev", "function_argument_list_impl",
  "function_argument_list_rev", "function_argument_list",
  "function_argument", "state_item", "$@28", "$@29", "state_contents",
  "group_item", "$@30", "$@31", "group_contents", "interface", "$@32",
  "interface_contents", "interface_property", "interface_item", "$@33",
  "link_item", "$@34", "$@35", "link_contents", "identifier_or_string",
  "assign_optional", "multi_assign_identifier", "constraint", "property",
  "property_flag_sign", "property_flags_contents", "property_flags_strict",
  "property_flags", "property_flag", "action",
  "selector_item_non_ambiguous", "selector_item", "selector_items", "$@36",
  "selector_explicit", "$@37", "selector", "selector_as_pseudo_arg",
  "selector_non_ambiguous_beginning", "$@38", "selector_non_ambiguous",
  "selector_non_ambiguous_as_pseudo_arg", "selector_parse_contents",
  "selector_parse", "selector_identifier", "$@39", "selector_regex",
  "selector_pseudo_simple_key_real", "selector_pseudo_simple_key",
  "selector_pseudo_simple", "selector_pseudo_selector_key_real",
  "selector_pseudo_selector_key", "selector_pseudo_hasflag_arg",
  "selector_pseudo_hasflag_args_rev", "selector_pseudo_hasflag_args",
  "selector_pseudo_hasflag", "selector_pseudo_strargs_key_real",
  "selector_pseudo_strargs_key", "selector_pseudo_strargs_args_rev",
  "selector_pseudo_strargs_args", "selector_pseudo_selector_args_rev",
  "$@40", "selector_pseudo_selector_args", "selector_pseudo_mixargs_key",
  "selector_pseudo_mixargs_arg", "selector_pseudo_mixargs_args_rev",
  "selector_pseudo_mixargs_args", "selector_pseudo_with_args", "$@41",
  "$@42", "selector_pseudo", "import", "layout", "$@43", "$@44",
  "relation_item", "relation", "layout_relative", "layout_item_relative",
  "layout_item_separator", "layout_item_absolute", "layout_item",
  "layout_item_or_others", "$@45", "layout_contents", "identifier",
  "double", "integer", "value_as_string", "string_item", "string_contents",
  "string", "$@46", "condition", "$@47", "$@48", "$@49", "equation",
  "$@50", "indirection_embedding_item", "indirection_embedding",
  "indirection_contents", "$@51", "indirection", "$@52", "regex", "$@53",
  "equation_item", "equation_contents", "equation_inside", "$@54",
  "condition_inside", "$@55", "$@56", "$@57", "map_item", "map_contents",
  "map_inside", "$@58", "reduce_item", "reduce_contents", "reduce_inside",
  "$@59", "indirection_inside", "$@60", "debug", "delete_item", "$@61",
  "delete", "delete_contents", "delete_context", "$@62", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   123,   125,    61,    63,    44,    58,    40,
      41,    91,    93,    46,    45,    43,   124,    60,    39
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   129,   130,   130,   130,   130,   130,   130,   131,   131,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
     132,   132,   132,   132,   133,   132,   134,   135,   137,   136,
     139,   138,   140,   140,   140,   140,   140,   140,   140,   142,
     141,   143,   143,   143,   143,   144,   144,   145,   145,   146,
     146,   147,   147,   148,   147,   149,   149,   150,   151,   151,
     152,   151,   153,   153,   155,   154,   156,   156,   156,   157,
     156,   158,   158,   160,   159,   162,   161,   163,   163,   163,
     163,   163,   163,   163,   164,   163,   165,   165,   166,   166,
     167,   167,   168,   169,   169,   170,   170,   172,   171,   173,
     171,   174,   175,   175,   176,   177,   177,   177,   178,   177,
     179,   179,   181,   180,   183,   182,   184,   182,   185,   185,
     186,   186,   187,   188,   188,   189,   189,   190,   190,   190,
     191,   191,   192,   193,   193,   194,   195,   195,   196,   197,
     197,   198,   198,   198,   198,   198,   198,   198,   198,   199,
     199,   200,   200,   200,   201,   201,   202,   202,   202,   203,
     203,   205,   204,   206,   204,   207,   204,   208,   204,   210,
     209,   211,   209,   213,   212,   214,   214,   215,   215,   216,
     216,   218,   217,   219,   219,   219,   220,   219,   221,   221,
     223,   222,   224,   224,   225,   226,   227,   227,   227,   227,
     228,   228,   228,   229,   229,   230,   231,   231,   232,   233,
     233,   234,   234,   234,   235,   234,   236,   234,   237,   237,
     238,   238,   238,   238,   238,   238,   239,   238,   238,   238,
     238,   240,   238,   241,   241,   243,   242,   244,   244,   245,
     246,   246,   247,   246,   248,   248,   248,   249,   248,   248,
     250,   248,   251,   251,   252,   252,   252,   253,   253,   254,
     254,   254,   255,   255,   255,   255,   256,   256,   257,   257,
     257,   258,   258,   259,   260,   260,   261,   261,   261,   261,
     262,   263,   263,   264,   264,   265,   266,   265,   265,   268,
     267,   269,   269,   270,   271,   271,   272,   271,   273,   273,
     274,   275,   275,   276,   278,   277,   279,   280,   280,   280,
     280,   280,   280,   280,   280,   280,   280,   280,   280,   280,
     280,   280,   280,   280,   280,   280,   280,   280,   280,   280,
     280,   281,   282,   283,   283,   283,   284,   285,   285,   286,
     286,   287,   288,   289,   289,   289,   289,   290,   291,   291,
     292,   293,   294,   293,   295,   296,   296,   296,   297,   297,
     298,   298,   299,   301,   300,   300,   300,   300,   302,   300,
     300,   300,   300,   303,   303,   304,   306,   305,   307,   305,
     308,   308,   308,   308,   309,   309,   310,   310,   311,   311,
     312,   312,   313,   313,   314,   314,   315,   315,   316,   315,
     317,   317,   318,   318,   319,   320,   321,   321,   321,   321,
     321,   321,   321,   322,   322,   322,   322,   322,   322,   322,
     322,   323,   323,   325,   324,   327,   328,   329,   326,   331,
     330,   332,   333,   333,   334,   335,   334,   334,   337,   336,
     339,   338,   340,   340,   341,   341,   343,   342,   345,   346,
     347,   344,   348,   348,   348,   348,   349,   349,   351,   350,
     352,   352,   352,   352,   353,   353,   355,   354,   357,   356,
     358,   358,   358,   359,   359,   360,   359,   361,   362,   362,
     364,   363
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     3,     2,     2,     2,     0,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     5,     1,     3,     0,     7,
       0,     6,     1,     1,     1,     1,     1,     1,     1,     0,
       4,     1,     1,     1,     1,     4,     2,     4,     2,     1,
       1,     1,     1,     0,     5,     0,     2,     3,     1,     1,
       0,     5,     0,     2,     0,     6,     3,     4,     1,     0,
       5,     0,     2,     0,     6,     0,     6,     1,     1,     1,
       1,     1,     1,     1,     0,     5,     0,     2,     2,     3,
       3,     2,     1,     0,     1,     0,     1,     0,     8,     0,
       8,     3,     0,     2,     4,     1,     1,     1,     0,     5,
       0,     2,     0,     9,     0,     8,     0,     8,     1,     1,
       1,     3,     1,     1,     3,     3,     4,     1,     3,     6,
       3,     4,     4,     1,     3,     1,     3,     1,     4,     3,
       4,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     0,     2,     3,     2,     3,     4,     2,     2,     0,
       1,     0,     9,     0,     8,     0,     7,     0,     8,     0,
       8,     0,     8,     0,     9,     0,     1,     0,     1,     0,
       3,     0,     9,     1,     1,     1,     0,     5,     0,     2,
       0,     6,     0,     2,     1,     7,     1,     1,     3,     3,
       1,     3,     3,     1,     3,     1,     1,     3,     1,     3,
       1,     1,     1,     1,     0,     6,     0,     5,     0,     2,
       1,     1,     1,     1,     1,     1,     0,     6,     1,     1,
       1,     0,     5,     0,     2,     0,     6,     0,     2,     6,
       1,     1,     0,     5,     1,     1,     1,     0,     6,     1,
       0,     5,     0,     2,     1,     1,     1,     1,     2,     5,
       3,     1,     0,     3,     5,     5,     6,     3,     0,     1,
       1,     2,     3,     2,     0,     1,     1,     1,     1,     1,
       5,     1,     1,     1,     1,     1,     0,     4,     3,     0,
       3,     1,     1,     1,     1,     3,     0,     4,     1,     1,
       1,     1,     2,     1,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     4,     1,     1,     1,     1,     1,     1,     3,
       1,     1,     0,     4,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     0,     5,     4,     3,     1,     0,     5,
       3,     1,     1,     1,     1,     5,     0,     6,     0,     4,
       1,     1,     1,     1,     1,     2,     0,     2,     3,     2,
       1,     1,     6,     5,     1,     1,     1,     1,     0,     5,
       0,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     2,     0,     4,     0,     0,     0,    10,     0,
       4,     3,     1,     2,     1,     0,     3,     1,     0,     4,
       0,     4,     1,     1,     0,     2,     0,     4,     0,     0,
       0,    10,     1,     1,     1,     1,     0,     2,     0,     4,
       1,     1,     1,     1,     0,     2,     0,     4,     0,     4,
       2,     2,     2,     1,     1,     0,     5,     2,     0,     2,
       0,     6
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       2,     8,   304,   233,   252,   218,     0,   151,   329,   333,
     334,   314,   308,   345,   307,   320,   309,   310,   311,   344,
     343,   312,   313,   315,   317,   326,   324,   325,   327,   328,
     355,   316,   321,   323,   322,   357,   356,   318,   319,     0,
     335,   346,   330,   440,   304,   284,   285,   301,   303,     0,
     283,     0,   282,   331,   332,   373,   336,     0,   372,   347,
     367,   371,   374,   281,   306,   151,   151,   151,     1,     0,
     151,   304,   304,    39,    26,     0,     9,    37,    34,    35,
      10,    23,    38,    49,    50,    36,    20,    32,    18,    11,
      15,    12,     0,    13,    14,    16,    17,    19,    33,    21,
      22,     0,   421,   302,   286,   304,     4,   403,   423,   438,
     305,   254,   255,   256,   363,     0,   368,   228,   221,   225,
       0,   223,   222,   230,   234,   224,   220,   229,   246,     0,
     253,   245,   244,   249,   212,     0,   219,   211,   213,   472,
     425,   404,   405,   429,   289,   294,   298,   299,   470,   410,
     412,   411,   471,   406,   408,   407,   409,   474,     0,   291,
     292,   473,   477,    46,    48,   421,     0,   123,   127,     0,
     137,     0,     0,     0,   152,   141,   142,   143,   144,   145,
     146,   147,   148,   149,     0,    95,    93,     0,     0,     0,
       0,     0,     0,     0,    95,   378,     0,     0,     0,     0,
      24,   276,   278,   279,   277,   337,   339,   341,     0,   338,
       0,   304,   288,   402,   421,     0,   304,   366,   350,     0,
     348,   370,     0,     0,    41,    42,    43,    44,   231,     0,
     261,     0,   250,     0,   261,   216,     0,   421,   421,   304,
     296,   304,   475,   304,   304,     0,     0,     0,     0,     0,
       0,     0,     0,   304,     0,   153,    93,    96,    93,   304,
     304,   304,   304,    92,    94,     0,    93,   159,    93,    30,
     190,     0,     0,    75,    73,    64,    93,    93,   376,   304,
      27,   480,     0,    93,    93,     8,     0,   342,   466,   458,
     448,   418,   441,   446,   468,   419,   420,   422,   413,   414,
     417,   416,   415,   287,     0,   434,   421,   432,   437,     0,
     293,   351,   354,     0,     0,   365,   300,   359,   360,   362,
       0,   358,   235,   233,   226,     0,   257,     0,   268,     0,
     267,   252,   247,     0,   218,   214,     0,     0,   290,   304,
     295,   478,    45,    47,    40,   125,   120,   122,     0,   119,
     118,   124,   128,     0,   130,     0,   136,     0,   139,   135,
       0,   133,     0,   150,     0,     0,     0,   158,   157,    91,
     165,     0,   304,   160,    93,     0,    55,   188,     0,     0,
      86,    71,    62,     0,     0,   400,     0,   380,   381,   383,
     382,     0,   384,   304,   394,   395,   379,   478,    28,     0,
       0,   151,   340,   464,   456,   421,   444,     0,   424,     0,
       0,   433,   439,   352,   364,   349,     0,   369,   237,   151,
     233,   260,   258,   269,   270,     0,   273,   274,   151,   252,
       0,   151,   218,   426,   430,   297,   151,     0,   126,     0,
     131,   138,     0,   140,   132,    97,    99,   304,   304,    90,
     252,   163,     0,   167,   151,   151,   375,     0,   151,     0,
     151,   114,   116,   151,     0,     0,   304,   389,   385,   151,
      71,   169,   171,    25,     0,     0,     0,     0,     0,   436,
     431,   304,   361,   151,   232,   151,     0,   271,     0,   275,
     262,   251,   151,   280,   217,   151,   421,   476,   479,   121,
       0,   134,   218,   218,   156,    88,   304,   151,   252,   161,
     252,    31,    52,    56,     0,    51,   191,   185,     0,   184,
     183,   189,   112,    76,    82,    87,    77,    80,     0,    78,
      79,    81,    83,    74,     0,    72,     0,     0,    68,    65,
      59,    58,    63,     0,     0,   233,   233,   377,   397,     0,
     396,   401,   390,   391,     0,     0,   388,   481,     0,   218,
     218,   467,   463,   460,   461,   465,   462,   459,   455,   452,
     453,   457,   454,   449,   443,   447,   442,   445,   469,   353,
     236,   241,     0,   240,   238,   227,   259,   272,     0,   266,
     248,   215,     0,   129,   151,   151,    89,   166,   151,   252,
     151,    53,     0,   186,     0,   110,    84,   154,     0,    69,
       0,     0,    60,     0,   151,   151,   398,   386,     0,    29,
     151,   151,   421,   242,     0,     0,   427,    98,   100,   164,
     151,   168,    55,     0,   188,   175,   151,    86,   155,    71,
      66,     0,    62,    57,   115,   117,   400,   304,   393,   386,
     170,   172,     0,   237,     0,     0,     0,   263,   421,   162,
     151,     0,   151,     0,   208,   176,   206,   210,     0,   113,
     107,   105,   111,     0,   106,   151,     0,    67,   151,   151,
     387,   392,   450,   151,     0,     0,     0,     0,    54,     0,
     187,   179,     0,     0,   102,   108,    85,    70,    61,   399,
     421,   243,     0,   264,   265,   428,   173,   177,     0,   207,
     209,     0,   110,     0,   239,   192,     0,     0,     0,   203,
     205,   178,   200,   181,   104,   103,     0,   151,   451,   194,
       0,     0,     0,   180,     0,     0,     0,   109,     0,   174,
     193,   201,   202,   204,   182,   101,     0,     0,     0,     0,
       0,   196,   197,   195,     0,   198,   199
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     6,     7,    76,   285,    77,    78,    79,   470,    80,
     376,   128,    82,   165,   229,    83,    84,    85,   513,   632,
     454,   541,   542,   642,   460,    86,   382,   535,   639,   459,
      87,   381,    88,   380,   525,   637,   458,   449,   263,   264,
     265,   256,   118,   502,   503,   725,   711,   671,   672,   712,
     636,    90,   605,   119,   545,   546,   346,   347,   348,   175,
     176,   177,   178,   179,   359,   360,   180,   181,   182,   183,
     184,   129,   536,   266,   374,   121,   599,   508,   450,   510,
     122,   559,   560,   519,   715,   663,   718,   708,   520,   735,
     521,   634,   455,   123,   377,   729,   730,   740,   753,   719,
     720,   721,   664,   665,   666,   136,   432,   334,    67,   124,
     420,   323,    65,   125,   418,   483,   583,   584,   653,   130,
     429,   331,    66,   230,   329,   231,   589,   131,   425,   426,
     330,   490,   205,   132,    45,    46,   159,   211,   160,   239,
     161,   311,   147,   339,   349,   317,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,   206,   207,   208,    58,
      59,    60,   218,   219,   312,   481,   313,    61,   318,   319,
     320,    62,   216,   222,    63,    96,   133,   385,   279,   392,
     393,   648,   394,   554,   395,   550,   551,   646,   463,   149,
     150,   151,   350,   297,   210,   153,   214,   154,   237,   496,
     658,   155,   238,   307,   308,   309,   409,   156,   215,    64,
     102,   577,   477,   298,   406,   299,   405,   622,   700,   571,
     475,   300,   404,   565,   474,   301,   403,   302,   407,    98,
     498,   341,    99,   436,   100,   397
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -451
static const yytype_int16 yypact[] =
{
     192,  -451,  2349,  -451,  -451,  -451,    31,    40,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,   -95,
    -451,  -451,  -451,  -451,  2582,  -451,  -451,    71,  -451,   -55,
    -451,   -45,  -451,  -451,  -451,  -451,  -451,   -73,  -451,  -451,
     -57,   -26,  -451,  -451,  -451,    74,   141,   150,  -451,  1535,
    1440,  2405,  2405,  -451,  -451,  2462,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,   265,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,   532,  -451,    71,  -451,  2582,  -451,   -64,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,    -2,   -15,  -451,  -451,  -451,
    2469,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,   711,
    -451,  -451,  -451,  -451,  -451,   802,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,   102,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,    59,    71,
    -451,  -451,  -451,    91,    96,  -451,     9,    25,    35,    37,
      39,    43,    45,    49,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,   -47,  2198,  1915,    19,    65,   423,
     423,    72,    76,    83,  2198,    97,   423,   111,   423,  2198,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,    87,   122,  -451,
     952,  2582,  -451,  -451,  -451,   -56,  2405,  -451,   114,   134,
    -451,  -451,  1820,   152,  -451,  -451,  -451,  -451,  -451,   169,
     172,   -48,  -451,   178,    13,  -451,   180,  -451,  -451,  2582,
    -451,  2582,  -451,  2405,  2405,  1825,  1630,   175,   409,  1725,
     190,   423,  1232,  2405,  1082,  -451,   196,  -451,   196,  2293,
    2405,  2405,  2405,  -451,  -451,   203,   196,    28,   196,  -451,
    -451,   277,   280,  -451,  -451,  -451,   196,   196,  -451,  2010,
    -451,  -451,   216,   196,   196,  -451,   532,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  2002,   246,  -451,  -451,   248,   251,
    -451,  -451,   244,   242,   423,  -451,  -451,  -451,  -451,  -451,
     120,  -451,  -451,  -451,  -451,   -45,  -451,   249,    95,   423,
    -451,  -451,  -451,   255,  -451,  -451,   816,  2203,    71,  2582,
      71,  -451,  -451,  -451,  -451,  -451,  -451,  -451,   131,  -451,
    -451,  -451,  -451,   259,  -451,   136,  -451,   245,  -451,  -451,
     144,  -451,   260,  -451,   266,   268,   368,  -451,  -451,   271,
    -451,   272,  2405,  -451,   196,   278,  -451,  -451,   -45,   -45,
    -451,  -451,  -451,   283,   286,  -451,   423,  -451,  -451,  -451,
    -451,   119,  -451,  2104,  -451,  -451,  -451,  -451,  -451,   293,
     305,   276,  -451,  -451,  -451,  -451,  -451,   -56,  -451,   248,
    2105,  -451,  -451,  -451,  -451,  -451,  1820,  -451,  -451,   531,
    -451,   302,  -451,  -451,  -451,   431,    24,   296,   817,  -451,
     423,   890,  -451,  -451,  -451,    71,  1240,  1820,  -451,   423,
    -451,  -451,   423,  -451,  -451,  -451,  -451,  2405,  2405,   309,
    -451,  -451,   314,  -451,  1086,  1090,  -451,   326,  1098,   317,
     226,  -451,  -451,   941,   -41,   423,  2104,  -451,  -451,  1340,
    -451,  -451,  -451,  -451,   273,   224,  1540,  1349,   325,   248,
    -451,  2405,  -451,  1104,  -451,  1118,   -45,  -451,   431,  -451,
     330,  -451,  1149,  -451,  -451,  1510,  -451,  -451,  -451,  -451,
     324,  -451,  -451,  -451,  -451,  -451,  2405,  1579,  -451,  -451,
    -451,  -451,  -451,  -451,   300,  -451,  -451,  -451,   270,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,    29,  -451,
    -451,  -451,  -451,  -451,  2532,  -451,   337,   154,  -451,  -451,
    -451,  -451,  -451,    60,   339,  -451,  -451,  -451,  -451,    61,
    -451,  -451,  -451,  -451,   423,   -41,  -451,  -451,   430,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,   405,  -451,  -451,  -451,  -451,  -451,   423,  -451,
    -451,  -451,  1635,  -451,  1674,  1769,  -451,  -451,  1864,  -451,
    1959,  -451,   -45,  -451,   333,  -451,  -451,  -451,    69,  -451,
     423,   340,  -451,   423,  2053,  2106,  -451,   432,   423,  -451,
    2173,  2242,  -451,  -451,   164,   126,  -451,  -451,  -451,  -451,
    2439,  -451,  -451,   345,  -451,   -45,   649,  -451,  -451,  -451,
    -451,   423,  -451,  -451,  -451,  -451,  -451,  2405,  -451,   432,
    -451,  -451,  1730,  -451,   -45,   423,   423,  -451,  -451,  -451,
    2442,   346,  2455,   350,   355,  -451,  -451,   360,   364,  -451,
    -451,  -451,  -451,   477,  -451,  2475,   463,  -451,   738,  1053,
    -451,  -451,  -451,  2493,   476,   363,   366,  2572,  -451,   367,
    -451,   365,   -45,   423,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,   -45,  -451,  -451,  -451,  -451,   123,   374,  -451,
    -451,   487,  -451,  2586,  -451,  -451,   370,   383,   371,  -451,
     400,  -451,  -451,  -451,  -451,  -451,   404,   746,  -451,  -451,
       3,   -45,   -45,  -451,   123,   423,   423,  -451,   505,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,   435,   514,   440,   433,
     168,  -451,  -451,   428,   221,  -451,  -451
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -451,  -451,   261,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,    -7,  -451,  -451,   -96,  -451,  -451,  -451,  -451,  -451,
     -83,  -451,  -451,  -451,   -88,  -451,  -451,  -451,  -451,  -449,
    -451,  -451,  -451,  -451,  -451,  -451,   -82,  -451,  -451,  -451,
    -211,   372,     7,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -155,  -451,  -451,    10,  -451,  -451,   125,  -451,   315,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,   311,
      42,    27,  -451,   304,  -451,    15,  -451,  -451,  -451,  -451,
      16,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,   -42,    -6,  -451,  -451,  -451,  -451,  -451,  -165,
    -451,  -451,  -451,  -451,  -119,  -451,  -451,  -451,  -326,  -451,
    -451,  -451,  -316,  -451,  -451,   -58,  -451,  -451,  -451,  -451,
    -451,  -451,  -305,    64,   -27,  -450,  -451,   -62,   173,  -451,
     179,  -451,  -406,  -451,   -65,   -92,     0,  -451,   -34,  -451,
     -61,   121,  -451,  -451,   -63,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,   319,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,   193,  -451,
    -451,  -451,  -451,  -451,  -451,  -440,   250,  -451,  -451,  -368,
     219,   -38,  -451,    57,  -451,   336,  -451,  -451,   -14,   -19,
    -451,  -451,   610,   142,  -153,    82,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -292,   211,   220,  -451,   215,  -451,  -451,
    -451,  -451,  -451,  -141,  -451,  -137,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -133,  -451,  -444,
     561,  -451,  -451,   236,  -451,  -451
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -436
static const yytype_int16 yytable[] =
{
      81,    95,    47,   126,   145,   137,   148,   419,   431,   537,
     163,   164,   245,   212,    89,   538,   411,    91,   531,   487,
     738,   558,    93,    94,   101,   468,   428,  -268,  -268,  -268,
    -268,    68,   111,   233,    92,   146,   185,   186,   305,   236,
      -3,   189,   106,   372,   103,   364,   114,   365,   107,   192,
     306,   194,   195,   108,   260,   371,   196,   375,   117,   109,
     134,   304,   115,   157,   213,   383,   384,   326,   327,    69,
     254,    70,   399,   400,    -5,   255,   552,   553,   328,   192,
     192,   192,   587,   140,   336,   337,   196,   196,   196,   141,
     142,   107,   120,   116,   135,   198,   108,   158,   468,   261,
     143,   111,   109,    69,   485,   221,   495,   243,   537,   199,
     111,   244,    71,    72,   538,   110,   111,   739,   217,   303,
     145,   145,   258,   268,   492,   198,   198,   198,   246,   145,
     325,   277,   269,   112,   145,    73,   284,    74,   716,   717,
     333,    -6,   606,   465,   247,   507,    71,    72,   423,   424,
      -7,   146,   146,   410,   248,   310,   249,   145,   250,   316,
     146,    75,   251,   452,   252,   146,   111,   111,   253,    73,
      69,    74,   242,   612,   616,   111,   594,   595,   270,    69,
     111,   145,   342,   343,   145,   273,   254,   411,   146,   274,
     676,   638,   362,   234,   104,    75,   275,   105,   366,   367,
     368,   369,   112,   598,   286,   600,   387,   388,   389,   390,
     278,   112,   146,    71,    72,   146,   107,   112,   391,   423,
     424,   108,    71,    72,   281,   240,   537,   109,   241,   614,
     615,   314,   538,   620,   621,   531,    73,   416,    74,   338,
     417,   340,   287,   655,   656,    73,   657,    74,   437,   257,
     267,   438,   476,   437,   315,    69,   440,    97,   257,   751,
     752,   442,    75,   283,   443,   322,   113,   112,   112,   610,
     611,    75,   185,   186,   187,   188,   112,   189,   190,   326,
     327,   112,   324,   191,   602,   192,   193,   194,   195,   325,
     192,   332,   196,   335,   630,   351,   197,   196,    71,    72,
       1,     2,     3,     4,     5,    69,   111,    70,   567,   290,
     356,   366,   755,   756,   262,   127,   370,   138,   568,   107,
     192,    73,   378,    74,   108,   379,   293,   196,   294,   398,
     109,   198,   467,   563,   569,   113,   198,   564,   570,   435,
     539,   566,   572,   592,   113,   199,    69,    75,    71,    72,
     113,   145,  -435,   316,   306,   561,   412,   126,   290,   111,
     111,   413,   414,   107,   422,   441,   198,   562,   108,   137,
     430,    73,   145,    74,   109,   293,   439,   294,   200,   445,
     444,   446,   146,   603,   447,   451,   504,   505,   448,   421,
     473,   453,   515,   107,    81,    95,   461,    75,   108,   462,
     113,   113,   391,   146,   109,   556,   471,   112,    89,   113,
     107,    91,   117,   601,   113,   108,    93,    94,   472,   486,
     310,   109,   328,   126,   134,   192,   506,   509,    92,   157,
     578,   533,   196,   137,   201,   202,   203,   204,   534,   522,
     111,   111,   456,   457,   593,   596,   120,   512,   517,   588,
     609,   524,   635,   540,   613,   641,   548,   647,   135,    69,
     112,   112,   157,   158,   661,   526,   689,   111,   527,   652,
     691,   198,   692,   529,   530,   693,   581,   694,   117,   702,
     706,   514,   518,   703,   707,   528,   704,   543,   134,   723,
     549,   733,    69,   731,   140,   111,   158,   192,   107,   111,
     141,   142,   107,   108,   196,   687,   732,   108,   140,   109,
     582,   143,   120,   109,   141,   142,   107,   734,   623,   736,
     746,   108,   135,   107,   544,   143,   747,   109,   108,   352,
     748,   749,   137,   137,   109,   201,   202,   203,   204,   111,
     113,   112,   112,   198,   619,   754,   401,   713,   750,   660,
     586,   534,   126,   126,   678,   675,   107,   727,   137,   137,
      69,   108,   499,   111,   355,   363,   276,   109,   112,   743,
     107,   373,   140,   709,   674,   108,   608,   697,   141,   142,
     107,   109,   604,   111,   534,   108,   680,   134,   134,   143,
     695,   109,   662,   113,   113,   683,   112,   654,   515,   488,
     112,   724,   579,    71,    72,   402,   489,   117,   117,   482,
     466,   681,   618,   134,   134,   396,   111,   140,   391,   576,
     479,   135,   135,   141,   142,   107,    73,   478,    74,   670,
     108,   162,   679,   469,   143,   111,   109,     0,     0,     0,
     112,   120,   120,     0,     0,   484,   624,   135,   135,     0,
       0,    97,    75,   512,   111,   517,     0,   111,     0,   111,
       0,     0,     0,   673,   112,   674,   633,     0,   524,   127,
       0,   540,   548,   111,   113,   113,   581,     0,    69,   152,
       0,   138,   526,   111,   112,   527,     0,   514,   111,   518,
     529,   530,     0,     0,     0,     0,     0,     0,     0,   667,
       0,   113,   528,     0,   668,   543,   549,     0,   532,     0,
     582,   209,   111,   111,     0,   111,     0,   112,   684,     0,
     670,    71,    72,     0,     0,   220,     0,     0,     0,   113,
       0,   192,     0,   113,   195,   127,   112,     0,   196,     0,
       0,     0,   544,     0,    73,   138,    74,     0,     0,     0,
       0,     0,     0,     0,   673,   112,   667,     0,   112,     0,
     112,     0,     0,   669,     0,     0,   714,    69,     0,     0,
      75,   722,     0,   113,   112,    69,     0,   198,     0,     0,
       0,     0,     0,     0,   112,   224,   225,   226,   227,   112,
       0,     0,     0,     0,     0,   741,   742,   113,   722,   271,
     272,   668,     0,     0,   107,     0,   280,     0,   282,   108,
      71,    72,     0,   112,   112,   109,   112,   113,    71,    72,
       0,     0,   192,     0,   232,   195,     0,     0,     0,   196,
       0,   107,   321,    73,     0,    74,   108,     0,     0,     0,
       0,    73,   109,    74,   138,   138,    69,     0,     0,     0,
     113,     0,   698,     0,     0,     0,     0,     0,   353,    75,
     737,   357,   361,     0,   127,   127,     0,    75,   198,   113,
     138,   138,     0,     0,     0,     0,   224,   225,   226,   227,
       0,     0,     0,     0,     0,     0,     0,     0,   113,    71,
      72,   113,     0,   113,     0,   107,   209,   288,     0,   289,
     108,   290,     0,     0,     0,     0,   109,   113,     0,     0,
     291,     0,    73,     0,    74,   235,     0,   113,   293,    69,
     294,     0,   113,     0,   415,   532,     0,     0,     0,   295,
     296,   491,     0,   433,     0,     0,     0,     0,    75,   427,
       0,     0,     0,     0,     0,     0,   113,   113,     0,   113,
       0,     8,     0,     0,     0,     0,     9,    10,     0,    11,
      12,     0,    71,    72,     0,   386,     0,     0,     0,    13,
      69,     0,     0,     0,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    73,     0,    74,     0,     0,
      25,    26,    27,    28,    29,    30,   464,    31,    32,    33,
      34,    35,    36,     0,   494,    37,    38,     0,    39,    40,
      41,    75,     0,    71,    72,     0,     0,     0,     0,    42,
       0,     0,     0,     0,     0,     0,   321,     0,   387,   388,
     389,   390,     0,   288,  -304,   289,    73,   290,    74,  -304,
     493,    43,     0,     0,     0,  -304,   291,     0,     0,   500,
       0,     0,   501,   292,   293,   547,   294,     0,     0,     0,
       0,     0,    75,     8,     0,   295,   296,   144,     9,    10,
       0,    11,    12,     0,     0,   555,     0,   386,     0,     0,
       0,    13,    69,     0,     0,     0,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,     0,     0,     0,
       0,     0,    25,    26,    27,    28,    29,    30,     0,    31,
      32,    33,    34,    35,    36,    69,     0,    37,    38,    69,
      39,    40,    41,     0,     0,    71,    72,    69,   166,   167,
     168,    42,     0,    69,     0,     0,   169,     0,     0,     0,
     387,   388,   389,   390,   170,   171,  -304,    69,    73,     0,
      74,  -304,   172,    43,     0,     0,     0,  -304,    71,    72,
       0,   173,    71,    72,   617,     0,     0,   699,     0,     0,
      71,    72,     0,     0,    75,     0,    71,    72,    69,   144,
       0,    73,     0,    74,     0,    73,     0,    74,     0,     0,
      71,    72,     0,    73,     0,    74,     0,     0,   625,    73,
     511,    74,     0,     0,   516,     0,     0,    75,     0,     0,
       0,    75,   523,    73,     0,    74,     0,     0,   580,    75,
     640,    71,    72,   643,     0,    75,     0,     0,   649,     0,
       0,     0,   585,     0,     0,     0,     0,     0,     0,    75,
       0,     0,     0,     0,    73,     0,    74,     0,     0,     0,
       8,   677,     0,     0,     0,     9,    10,     0,    11,    12,
       0,     0,     0,   590,     0,   685,   686,     0,    13,    69,
      75,     0,     0,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,     0,     0,     0,     0,     0,    25,
      26,    27,    28,    29,    30,     0,    31,    32,    33,    34,
      35,    36,     0,   710,    37,    38,     0,    39,    40,    41,
       0,     0,    71,    72,     0,     0,     0,   140,    42,     0,
       0,   726,     0,   141,   142,   107,     0,     0,     0,     0,
     108,     0,     0,  -304,   143,    73,   109,    74,  -304,     0,
      43,     0,     0,     0,  -304,   744,   745,     0,     0,     0,
       8,     0,   358,     0,   497,     9,    10,     0,    11,    12,
       0,    75,     0,     0,     0,     0,   144,     0,    13,    69,
       0,     0,     0,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,     0,     0,     0,     0,     0,    25,
      26,    27,    28,    29,    30,     0,    31,    32,    33,    34,
      35,    36,     0,     0,    37,    38,     0,    39,    40,    41,
       0,     0,    71,    72,     0,     0,     0,     0,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     288,     0,   289,  -304,   290,    73,     0,    74,  -304,     0,
      43,     0,   574,   291,  -304,     0,     0,     0,     0,     0,
       8,   293,   575,   294,   557,     9,    10,     0,    11,    12,
       0,    75,   295,   296,     0,     0,   144,     0,    13,    69,
       0,     0,     0,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,     0,     0,     0,     0,     0,    25,
      26,    27,    28,    29,    30,     0,    31,    32,    33,    34,
      35,    36,     0,     0,    37,    38,     0,    39,    40,    41,
       0,     0,    71,    72,     0,     0,     0,     0,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -304,     0,    73,     0,    74,  -304,    69,
      43,     0,     0,     0,  -304,     8,     0,     0,     0,     0,
       9,    10,     0,    11,    12,     0,     0,     0,     0,     0,
       0,    75,     0,    13,     0,     0,   144,     0,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,   139,
       0,     0,    71,    72,    25,    26,    27,    28,    29,    30,
       0,    31,    32,    33,    34,    35,    36,     0,     0,    37,
      38,     0,    39,    40,    41,    73,     0,    74,    69,     0,
       0,     0,     0,    42,     0,     0,     0,     0,     0,     0,
     140,   288,     0,   289,   591,   290,   141,   142,   107,     0,
       0,    75,     0,   108,   291,    43,     0,   143,     0,   109,
       8,     0,   293,     0,   294,     9,    10,     0,    11,    12,
       0,    71,    72,   295,   296,     0,     0,   573,    13,     0,
       0,   144,     0,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    73,     0,    74,     0,     0,    25,
      26,    27,    28,    29,    30,     0,    31,    32,    33,    34,
      35,    36,     0,   597,    37,    38,     0,    39,    40,    41,
      75,     0,     0,    69,     0,     0,     0,     0,    42,     0,
       0,     0,     0,     0,     0,   140,   288,     0,   289,     0,
     290,   141,   142,   107,     0,     0,     0,     0,   108,   291,
      43,     0,   143,     0,   109,     8,     0,   293,     0,   294,
       9,    10,     0,    11,    12,     0,    71,    72,   295,   296,
     345,     0,   626,    13,     0,     0,   144,     0,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    73,
       0,    74,     0,     0,    25,    26,    27,    28,    29,    30,
       0,    31,    32,    33,    34,    35,    36,     0,   627,    37,
      38,     0,    39,    40,    41,    75,     0,     0,    69,     0,
       0,     0,     0,    42,     0,     0,     0,     0,     0,     0,
     140,   288,     0,   289,     0,   290,   141,   142,   107,     0,
       0,     0,     0,   108,   291,    43,     0,   143,     0,   109,
       8,     0,   293,     0,   294,     9,    10,     0,    11,    12,
       0,    71,    72,   295,   296,   354,     0,   682,    13,     0,
       0,   144,     0,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    73,     0,    74,     0,     0,    25,
      26,    27,    28,    29,    30,     0,    31,    32,    33,    34,
      35,    36,     0,   628,    37,    38,     0,    39,    40,    41,
      75,     0,     0,    69,     0,     0,     0,     0,    42,     0,
       0,     0,     0,     0,     0,   140,   288,     0,   289,     0,
     290,   141,   142,   107,     0,     0,     0,     0,   108,   291,
      43,   344,   143,     0,   109,     8,     0,   293,     0,   294,
     259,    10,     0,    11,    12,     0,    71,    72,   295,   296,
       0,   260,     0,    13,     0,     0,   144,     0,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    73,
       0,    74,     0,     0,    25,    26,    27,    28,    29,    30,
       0,    31,    32,    33,    34,    35,    36,     0,   629,    37,
      38,     0,    39,    40,    41,    75,   261,     0,    69,     0,
       0,     0,     0,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   107,     0,
       0,     0,     0,   108,     0,    43,     0,     0,     0,   109,
       8,     0,     0,     0,     0,     9,    10,     0,    11,    12,
       0,    71,    72,   262,   386,     0,     0,     0,    13,     0,
       0,   144,     0,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    73,     0,    74,     0,     0,    25,
      26,    27,    28,    29,    30,     0,    31,    32,    33,    34,
      35,    36,     0,   631,    37,    38,     0,    39,    40,    41,
      75,     0,    69,   288,     0,   289,     0,   290,    42,     0,
       0,     0,     0,     0,     0,     0,   291,   387,   388,   389,
     390,   408,     0,     0,   293,     0,   294,     0,     0,     0,
      43,     0,     0,     0,     8,   295,   296,     0,     0,     9,
      10,     0,    11,    12,     0,    71,    72,     0,     0,     0,
       0,     0,    13,     0,     0,    69,   144,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    73,     0,
      74,     0,     0,    25,    26,    27,    28,    29,    30,     0,
      31,    32,    33,    34,    35,    36,     0,   644,    37,    38,
       0,    39,    40,    41,    75,     0,     0,     0,    71,    72,
       0,     0,    42,     0,     0,     0,   288,     0,   289,     0,
     290,   387,   388,   389,   390,     0,     0,     0,     0,   291,
       0,    73,    69,    74,    43,     0,     0,   293,     8,   294,
       0,     0,   480,     9,    10,     0,    11,    12,   295,   296,
     645,     0,     0,     0,     0,     0,    13,    75,     0,     0,
     144,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,     0,     0,     0,    71,    72,    25,    26,    27,
      28,    29,    30,     0,    31,    32,    33,    34,    35,    36,
       0,     0,    37,    38,     0,    39,    40,    41,    73,     0,
      74,    69,     0,     0,     0,     0,    42,     0,     0,     0,
       0,     0,     0,     0,   288,     0,   289,   650,   290,     0,
       0,   107,     0,     0,    75,     0,   108,   291,    43,     0,
       0,     0,   109,     8,     0,   293,   434,   294,     9,    10,
       0,    11,    12,     0,    71,    72,   295,   296,     0,     0,
       0,    13,     0,     0,   144,     0,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    73,     0,    74,
       0,     0,    25,    26,    27,    28,    29,    30,     0,    31,
      32,    33,    34,    35,    36,     0,   651,    37,    38,     8,
      39,    40,    41,    75,     9,    10,     0,    11,    12,     0,
       0,    42,     0,     0,     0,     0,     0,    13,     0,     0,
       0,     0,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    43,     0,     0,     0,     0,    25,    26,
      27,    28,    29,    30,     0,    31,    32,    33,    34,    35,
      36,     0,  -333,    37,    38,     8,    39,    40,    41,   144,
       9,    10,     0,    11,    12,     0,     0,    42,     0,     0,
       0,     0,     0,    13,     0,     0,     0,     0,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    43,
       0,     0,     0,     0,    25,    26,    27,    28,    29,    30,
       0,    31,    32,    33,    34,    35,    36,     0,    69,    37,
      38,    69,    39,    40,    41,    44,   185,   186,     0,   188,
     223,     0,     0,    42,    69,     0,     0,     0,     0,   192,
       0,   194,   195,     0,     0,     0,   196,     0,     0,     0,
       0,     0,     0,     0,    69,    43,     0,     0,   166,   167,
     168,    71,    72,     0,    71,    72,   169,     0,     0,     0,
       0,     0,    69,     0,   170,   171,     0,    71,    72,     0,
       0,   144,   172,     0,    73,   198,    74,    73,     0,    74,
       0,   173,     0,   224,   225,   226,   227,    71,    72,   199,
      73,     0,    74,   659,     0,     0,   688,     0,     0,     0,
      75,     0,   107,    75,     0,    71,    72,   108,     0,   690,
      73,     0,    74,   109,     0,     0,    75,     0,   166,   167,
     168,     0,   228,     0,   174,     0,   169,     0,    73,   696,
      74,     0,     8,     0,   170,   171,    75,     9,    10,     0,
      11,    12,   172,     0,     0,     0,     0,   701,     0,     0,
      13,   173,     0,     0,    75,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,     0,     0,     0,     0,
       0,    25,    26,    27,    28,    29,    30,     0,    31,    32,
      33,    34,    35,    36,     0,     0,    37,    38,     0,    39,
      40,    41,     0,   288,   607,   289,     0,   290,   705,     0,
      42,     0,     0,     0,     0,     0,   291,   288,     0,   289,
       0,   290,   728,     0,   293,     0,   294,     0,     0,     0,
     291,     0,    43,     0,     0,   295,   296,     0,   293,     0,
     294,     0,     0,     0,     0,     0,     0,     0,     0,   295,
     296
};

static const yytype_int16 yycheck[] =
{
       7,     7,     2,    65,    69,    67,    69,   323,   334,   459,
      71,    72,   165,   105,     7,   459,   308,     7,   458,   425,
      17,   470,     7,     7,   119,   393,   331,     3,     4,     5,
       6,     0,    51,   129,     7,    69,     7,     8,    94,   135,
       0,    12,    97,    15,    44,   256,   119,   258,    93,    20,
     106,    22,    23,    98,    26,   266,    27,   268,    65,   104,
      67,   214,   119,    70,   128,   276,   277,   115,   116,    29,
     117,    31,   283,   284,     0,   122,   117,   118,   126,    20,
      20,    20,   488,    85,   237,   238,    27,    27,    27,    91,
      92,    93,    65,   119,    67,    66,    98,    70,   466,    71,
     102,   120,   104,    29,   420,   120,   432,    16,   558,    80,
     129,    15,    72,    73,   558,    51,   135,   114,   120,   211,
     185,   186,   185,   186,   429,    66,    66,    66,   119,   194,
     117,   194,   113,    51,   199,    95,   199,    97,    15,    16,
     127,     0,   113,    24,   119,   450,    72,    73,   124,   125,
       0,   185,   186,   306,   119,   216,   119,   222,   119,   222,
     194,   121,   119,   374,   119,   199,   185,   186,   119,    95,
      29,    97,   113,   113,   113,   194,   502,   503,   113,    29,
     199,   246,   243,   244,   249,   113,   117,   479,   222,   113,
     639,   122,   253,   129,   123,   121,   113,   126,   259,   260,
     261,   262,   120,   508,   117,   510,    87,    88,    89,    90,
     113,   129,   246,    72,    73,   249,    93,   135,   279,   124,
     125,    98,    72,    73,   113,   123,   676,   104,   126,   545,
     546,   117,   676,   559,   560,   675,    95,   117,    97,   239,
     120,   241,   120,   117,   118,    95,   120,    97,   117,   185,
     186,   120,   405,   117,   120,    29,   120,     7,   194,    91,
      92,   117,   121,   199,   120,   113,    51,   185,   186,   115,
     116,   121,     7,     8,     9,    10,   194,    12,    13,   115,
     116,   199,   113,    18,    14,    20,    21,    22,    23,   117,
      20,   113,    27,   113,   599,   120,    31,    27,    72,    73,
     108,   109,   110,   111,   112,    29,   325,    31,    84,    85,
     120,   372,    91,    92,   118,    65,   113,    67,    94,    93,
      20,    95,    45,    97,    98,    45,   102,    27,   104,   113,
     104,    66,   393,   474,   475,   120,    66,   474,   475,   339,
     114,   474,   475,   496,   129,    80,    29,   121,    72,    73,
     135,   416,   106,   416,   106,    82,   105,   419,    85,   378,
     379,   117,   120,    93,   115,   120,    66,    94,    98,   431,
     115,    95,   437,    97,   104,   102,   117,   104,   113,   113,
     120,   113,   416,   113,    16,   113,   447,   448,   117,   325,
     114,   113,   454,    93,   401,   401,   113,   121,    98,   113,
     185,   186,   463,   437,   104,   466,   113,   325,   401,   194,
      93,   401,   419,   113,   199,    98,   401,   401,   113,   117,
     481,   104,   126,   485,   431,    20,   117,   113,   401,   436,
     105,   114,    27,   495,     3,     4,     5,     6,   121,   113,
     459,   460,   378,   379,   120,   506,   419,   454,   455,   119,
     113,   458,   119,   460,   115,   115,   463,    25,   431,    29,
     378,   379,   469,   436,   119,   458,   120,   486,   458,   622,
     120,    66,   117,   458,   458,   115,   483,   113,   485,     3,
     113,   454,   455,   120,   119,   458,   120,   460,   495,   115,
     463,   120,    29,   123,    85,   514,   469,    20,    93,   518,
      91,    92,    93,    98,    27,   658,   123,    98,    85,   104,
     483,   102,   485,   104,    91,    92,    93,   117,   113,   115,
      15,    98,   495,    93,   460,   102,    91,   104,    98,   120,
      16,    91,   594,   595,   104,     3,     4,     5,     6,   558,
     325,   459,   460,    66,   114,   117,   285,   700,   115,   632,
     486,   121,   614,   615,   642,   637,    93,   712,   620,   621,
      29,    98,   437,   582,   249,   254,   194,   104,   486,   734,
      93,   267,    85,   692,   636,    98,   534,   114,    91,    92,
      93,   104,   518,   602,   121,    98,   647,   594,   595,   102,
     113,   104,   634,   378,   379,   653,   514,   624,   660,   426,
     518,   114,   481,    72,    73,   286,   427,   614,   615,   416,
     391,   649,   555,   620,   621,   279,   635,    85,   679,   477,
     409,   594,   595,    91,    92,    93,    95,   407,    97,   636,
      98,    70,   646,   397,   102,   654,   104,    -1,    -1,    -1,
     558,   614,   615,    -1,    -1,   114,   582,   620,   621,    -1,
      -1,   401,   121,   660,   673,   662,    -1,   676,    -1,   678,
      -1,    -1,    -1,   636,   582,   727,   602,    -1,   675,   419,
      -1,   678,   679,   692,   459,   460,   683,    -1,    29,    69,
      -1,   431,   675,   702,   602,   675,    -1,   660,   707,   662,
     675,   675,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   635,
      -1,   486,   675,    -1,    55,   678,   679,    -1,   458,    -1,
     683,   101,   731,   732,    -1,   734,    -1,   635,   654,    -1,
     727,    72,    73,    -1,    -1,   115,    -1,    -1,    -1,   514,
      -1,    20,    -1,   518,    23,   485,   654,    -1,    27,    -1,
      -1,    -1,   678,    -1,    95,   495,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   727,   673,   692,    -1,   676,    -1,
     678,    -1,    -1,   114,    -1,    -1,   702,    29,    -1,    -1,
     121,   707,    -1,   558,   692,    29,    -1,    66,    -1,    -1,
      -1,    -1,    -1,    -1,   702,    74,    75,    76,    77,   707,
      -1,    -1,    -1,    -1,    -1,   731,   732,   582,   734,   189,
     190,    55,    -1,    -1,    93,    -1,   196,    -1,   198,    98,
      72,    73,    -1,   731,   732,   104,   734,   602,    72,    73,
      -1,    -1,    20,    -1,   113,    23,    -1,    -1,    -1,    27,
      -1,    93,   222,    95,    -1,    97,    98,    -1,    -1,    -1,
      -1,    95,   104,    97,   594,   595,    29,    -1,    -1,    -1,
     635,    -1,   114,    -1,    -1,    -1,    -1,    -1,   248,   121,
     114,   251,   252,    -1,   614,   615,    -1,   121,    66,   654,
     620,   621,    -1,    -1,    -1,    -1,    74,    75,    76,    77,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   673,    72,
      73,   676,    -1,   678,    -1,    93,   286,    81,    -1,    83,
      98,    85,    -1,    -1,    -1,    -1,   104,   692,    -1,    -1,
      94,    -1,    95,    -1,    97,   113,    -1,   702,   102,    29,
     104,    -1,   707,    -1,   314,   675,    -1,    -1,    -1,   113,
     114,   114,    -1,   117,    -1,    -1,    -1,    -1,   121,   329,
      -1,    -1,    -1,    -1,    -1,    -1,   731,   732,    -1,   734,
      -1,    10,    -1,    -1,    -1,    -1,    15,    16,    -1,    18,
      19,    -1,    72,    73,    -1,    24,    -1,    -1,    -1,    28,
      29,    -1,    -1,    -1,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    95,    -1,    97,    -1,    -1,
      49,    50,    51,    52,    53,    54,   386,    56,    57,    58,
      59,    60,    61,    -1,   114,    64,    65,    -1,    67,    68,
      69,   121,    -1,    72,    73,    -1,    -1,    -1,    -1,    78,
      -1,    -1,    -1,    -1,    -1,    -1,   416,    -1,    87,    88,
      89,    90,    -1,    81,    93,    83,    95,    85,    97,    98,
     430,   100,    -1,    -1,    -1,   104,    94,    -1,    -1,   439,
      -1,    -1,   442,   101,   102,   114,   104,    -1,    -1,    -1,
      -1,    -1,   121,    10,    -1,   113,   114,   126,    15,    16,
      -1,    18,    19,    -1,    -1,   465,    -1,    24,    -1,    -1,
      -1,    28,    29,    -1,    -1,    -1,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    -1,    -1,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    -1,    56,
      57,    58,    59,    60,    61,    29,    -1,    64,    65,    29,
      67,    68,    69,    -1,    -1,    72,    73,    29,    46,    47,
      48,    78,    -1,    29,    -1,    -1,    54,    -1,    -1,    -1,
      87,    88,    89,    90,    62,    63,    93,    29,    95,    -1,
      97,    98,    70,   100,    -1,    -1,    -1,   104,    72,    73,
      -1,    79,    72,    73,   554,    -1,    -1,   114,    -1,    -1,
      72,    73,    -1,    -1,   121,    -1,    72,    73,    29,   126,
      -1,    95,    -1,    97,    -1,    95,    -1,    97,    -1,    -1,
      72,    73,    -1,    95,    -1,    97,    -1,    -1,   588,    95,
     114,    97,    -1,    -1,   114,    -1,    -1,   121,    -1,    -1,
      -1,   121,   114,    95,    -1,    97,    -1,    -1,   114,   121,
     610,    72,    73,   613,    -1,   121,    -1,    -1,   618,    -1,
      -1,    -1,   114,    -1,    -1,    -1,    -1,    -1,    -1,   121,
      -1,    -1,    -1,    -1,    95,    -1,    97,    -1,    -1,    -1,
      10,   641,    -1,    -1,    -1,    15,    16,    -1,    18,    19,
      -1,    -1,    -1,   114,    -1,   655,   656,    -1,    28,    29,
     121,    -1,    -1,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    -1,    -1,    -1,    -1,    -1,    49,
      50,    51,    52,    53,    54,    -1,    56,    57,    58,    59,
      60,    61,    -1,   693,    64,    65,    -1,    67,    68,    69,
      -1,    -1,    72,    73,    -1,    -1,    -1,    85,    78,    -1,
      -1,   711,    -1,    91,    92,    93,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    93,   102,    95,   104,    97,    98,    -1,
     100,    -1,    -1,    -1,   104,   735,   736,    -1,    -1,    -1,
      10,    -1,   120,    -1,   114,    15,    16,    -1,    18,    19,
      -1,   121,    -1,    -1,    -1,    -1,   126,    -1,    28,    29,
      -1,    -1,    -1,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    -1,    -1,    -1,    -1,    -1,    49,
      50,    51,    52,    53,    54,    -1,    56,    57,    58,    59,
      60,    61,    -1,    -1,    64,    65,    -1,    67,    68,    69,
      -1,    -1,    72,    73,    -1,    -1,    -1,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      81,    -1,    83,    93,    85,    95,    -1,    97,    98,    -1,
     100,    -1,    93,    94,   104,    -1,    -1,    -1,    -1,    -1,
      10,   102,   103,   104,   114,    15,    16,    -1,    18,    19,
      -1,   121,   113,   114,    -1,    -1,   126,    -1,    28,    29,
      -1,    -1,    -1,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    -1,    -1,    -1,    -1,    -1,    49,
      50,    51,    52,    53,    54,    -1,    56,    57,    58,    59,
      60,    61,    -1,    -1,    64,    65,    -1,    67,    68,    69,
      -1,    -1,    72,    73,    -1,    -1,    -1,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    93,    -1,    95,    -1,    97,    98,    29,
     100,    -1,    -1,    -1,   104,    10,    -1,    -1,    -1,    -1,
      15,    16,    -1,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,   121,    -1,    28,    -1,    -1,   126,    -1,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      -1,    -1,    72,    73,    49,    50,    51,    52,    53,    54,
      -1,    56,    57,    58,    59,    60,    61,    -1,    -1,    64,
      65,    -1,    67,    68,    69,    95,    -1,    97,    29,    -1,
      -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,
      85,    81,    -1,    83,   114,    85,    91,    92,    93,    -1,
      -1,   121,    -1,    98,    94,   100,    -1,   102,    -1,   104,
      10,    -1,   102,    -1,   104,    15,    16,    -1,    18,    19,
      -1,    72,    73,   113,   114,    -1,    -1,   117,    28,    -1,
      -1,   126,    -1,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    95,    -1,    97,    -1,    -1,    49,
      50,    51,    52,    53,    54,    -1,    56,    57,    58,    59,
      60,    61,    -1,   114,    64,    65,    -1,    67,    68,    69,
     121,    -1,    -1,    29,    -1,    -1,    -1,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    85,    81,    -1,    83,    -1,
      85,    91,    92,    93,    -1,    -1,    -1,    -1,    98,    94,
     100,    -1,   102,    -1,   104,    10,    -1,   102,    -1,   104,
      15,    16,    -1,    18,    19,    -1,    72,    73,   113,   114,
     120,    -1,   117,    28,    -1,    -1,   126,    -1,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    95,
      -1,    97,    -1,    -1,    49,    50,    51,    52,    53,    54,
      -1,    56,    57,    58,    59,    60,    61,    -1,   114,    64,
      65,    -1,    67,    68,    69,   121,    -1,    -1,    29,    -1,
      -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,
      85,    81,    -1,    83,    -1,    85,    91,    92,    93,    -1,
      -1,    -1,    -1,    98,    94,   100,    -1,   102,    -1,   104,
      10,    -1,   102,    -1,   104,    15,    16,    -1,    18,    19,
      -1,    72,    73,   113,   114,   120,    -1,   117,    28,    -1,
      -1,   126,    -1,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    95,    -1,    97,    -1,    -1,    49,
      50,    51,    52,    53,    54,    -1,    56,    57,    58,    59,
      60,    61,    -1,   114,    64,    65,    -1,    67,    68,    69,
     121,    -1,    -1,    29,    -1,    -1,    -1,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    85,    81,    -1,    83,    -1,
      85,    91,    92,    93,    -1,    -1,    -1,    -1,    98,    94,
     100,    96,   102,    -1,   104,    10,    -1,   102,    -1,   104,
      15,    16,    -1,    18,    19,    -1,    72,    73,   113,   114,
      -1,    26,    -1,    28,    -1,    -1,   126,    -1,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    95,
      -1,    97,    -1,    -1,    49,    50,    51,    52,    53,    54,
      -1,    56,    57,    58,    59,    60,    61,    -1,   114,    64,
      65,    -1,    67,    68,    69,   121,    71,    -1,    29,    -1,
      -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      -1,    -1,    -1,    98,    -1,   100,    -1,    -1,    -1,   104,
      10,    -1,    -1,    -1,    -1,    15,    16,    -1,    18,    19,
      -1,    72,    73,   118,    24,    -1,    -1,    -1,    28,    -1,
      -1,   126,    -1,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    95,    -1,    97,    -1,    -1,    49,
      50,    51,    52,    53,    54,    -1,    56,    57,    58,    59,
      60,    61,    -1,   114,    64,    65,    -1,    67,    68,    69,
     121,    -1,    29,    81,    -1,    83,    -1,    85,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    87,    88,    89,
      90,    99,    -1,    -1,   102,    -1,   104,    -1,    -1,    -1,
     100,    -1,    -1,    -1,    10,   113,   114,    -1,    -1,    15,
      16,    -1,    18,    19,    -1,    72,    73,    -1,    -1,    -1,
      -1,    -1,    28,    -1,    -1,    29,   126,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    95,    -1,
      97,    -1,    -1,    49,    50,    51,    52,    53,    54,    -1,
      56,    57,    58,    59,    60,    61,    -1,   114,    64,    65,
      -1,    67,    68,    69,   121,    -1,    -1,    -1,    72,    73,
      -1,    -1,    78,    -1,    -1,    -1,    81,    -1,    83,    -1,
      85,    87,    88,    89,    90,    -1,    -1,    -1,    -1,    94,
      -1,    95,    29,    97,   100,    -1,    -1,   102,    10,   104,
      -1,    -1,   107,    15,    16,    -1,    18,    19,   113,   114,
     114,    -1,    -1,    -1,    -1,    -1,    28,   121,    -1,    -1,
     126,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    -1,    -1,    -1,    72,    73,    49,    50,    51,
      52,    53,    54,    -1,    56,    57,    58,    59,    60,    61,
      -1,    -1,    64,    65,    -1,    67,    68,    69,    95,    -1,
      97,    29,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    83,   114,    85,    -1,
      -1,    93,    -1,    -1,   121,    -1,    98,    94,   100,    -1,
      -1,    -1,   104,    10,    -1,   102,   103,   104,    15,    16,
      -1,    18,    19,    -1,    72,    73,   113,   114,    -1,    -1,
      -1,    28,    -1,    -1,   126,    -1,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    95,    -1,    97,
      -1,    -1,    49,    50,    51,    52,    53,    54,    -1,    56,
      57,    58,    59,    60,    61,    -1,   114,    64,    65,    10,
      67,    68,    69,   121,    15,    16,    -1,    18,    19,    -1,
      -1,    78,    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,
      -1,    -1,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,   100,    -1,    -1,    -1,    -1,    49,    50,
      51,    52,    53,    54,    -1,    56,    57,    58,    59,    60,
      61,    -1,   119,    64,    65,    10,    67,    68,    69,   126,
      15,    16,    -1,    18,    19,    -1,    -1,    78,    -1,    -1,
      -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,   100,
      -1,    -1,    -1,    -1,    49,    50,    51,    52,    53,    54,
      -1,    56,    57,    58,    59,    60,    61,    -1,    29,    64,
      65,    29,    67,    68,    69,   126,     7,     8,    -1,    10,
      11,    -1,    -1,    78,    29,    -1,    -1,    -1,    -1,    20,
      -1,    22,    23,    -1,    -1,    -1,    27,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    29,   100,    -1,    -1,    46,    47,
      48,    72,    73,    -1,    72,    73,    54,    -1,    -1,    -1,
      -1,    -1,    29,    -1,    62,    63,    -1,    72,    73,    -1,
      -1,   126,    70,    -1,    95,    66,    97,    95,    -1,    97,
      -1,    79,    -1,    74,    75,    76,    77,    72,    73,    80,
      95,    -1,    97,   114,    -1,    -1,   114,    -1,    -1,    -1,
     121,    -1,    93,   121,    -1,    72,    73,    98,    -1,   114,
      95,    -1,    97,   104,    -1,    -1,   121,    -1,    46,    47,
      48,    -1,   113,    -1,   122,    -1,    54,    -1,    95,   114,
      97,    -1,    10,    -1,    62,    63,   121,    15,    16,    -1,
      18,    19,    70,    -1,    -1,    -1,    -1,   114,    -1,    -1,
      28,    79,    -1,    -1,   121,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    -1,    -1,    -1,    -1,
      -1,    49,    50,    51,    52,    53,    54,    -1,    56,    57,
      58,    59,    60,    61,    -1,    -1,    64,    65,    -1,    67,
      68,    69,    -1,    81,   122,    83,    -1,    85,    86,    -1,
      78,    -1,    -1,    -1,    -1,    -1,    94,    81,    -1,    83,
      -1,    85,    86,    -1,   102,    -1,   104,    -1,    -1,    -1,
      94,    -1,   100,    -1,    -1,   113,   114,    -1,   102,    -1,
     104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   108,   109,   110,   111,   112,   130,   131,    10,    15,
      16,    18,    19,    28,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    49,    50,    51,    52,    53,
      54,    56,    57,    58,    59,    60,    61,    64,    65,    67,
      68,    69,    78,   100,   126,   263,   264,   265,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   288,   289,
     290,   296,   300,   303,   338,   241,   251,   237,     0,    29,
      31,    72,    73,    95,    97,   121,   132,   134,   135,   136,
     138,   140,   141,   144,   145,   146,   154,   159,   161,   171,
     180,   182,   200,   204,   209,   222,   304,   305,   358,   361,
     363,   119,   339,   265,   123,   126,    97,    93,    98,   104,
     252,   318,   324,   336,   119,   119,   119,   140,   171,   182,
     200,   204,   209,   222,   238,   242,   256,   305,   140,   200,
     248,   256,   262,   305,   140,   200,   234,   256,   305,    44,
      85,    91,    92,   102,   126,   263,   267,   271,   273,   318,
     319,   320,   321,   324,   326,   330,   336,   140,   200,   265,
     267,   269,   359,   269,   269,   142,    46,    47,    48,    54,
      62,    63,    70,    79,   122,   188,   189,   190,   191,   192,
     195,   196,   197,   198,   199,     7,     8,     9,    10,    12,
      13,    18,    20,    21,    22,    23,    27,    31,    66,    80,
     113,     3,     4,     5,     6,   261,   285,   286,   287,   321,
     323,   266,   264,   128,   325,   337,   301,   120,   291,   292,
     321,   120,   302,    11,    74,    75,    76,    77,   113,   143,
     252,   254,   113,   143,   252,   113,   143,   327,   331,   268,
     123,   126,   113,    16,    15,   323,   119,   119,   119,   119,
     119,   119,   119,   119,   117,   122,   170,   252,   273,    15,
      26,    71,   118,   167,   168,   169,   202,   252,   273,   113,
     113,   321,   321,   113,   113,   113,   170,   273,   113,   307,
     321,   113,   321,   252,   273,   133,   117,   120,    81,    83,
      85,    94,   101,   102,   104,   113,   114,   322,   342,   344,
     350,   354,   356,   264,   323,    94,   106,   332,   333,   334,
     269,   270,   293,   295,   117,   120,   273,   274,   297,   298,
     299,   321,   113,   240,   113,   117,   115,   116,   126,   253,
     259,   250,   113,   127,   236,   113,   323,   323,   265,   272,
     265,   360,   269,   269,    96,   120,   185,   186,   187,   273,
     321,   120,   120,   321,   120,   187,   120,   321,   120,   193,
     194,   321,   269,   198,   169,   169,   269,   269,   269,   269,
     113,   169,    15,   202,   203,   169,   139,   223,    45,    45,
     162,   160,   155,   169,   169,   306,    24,    87,    88,    89,
      90,   269,   308,   309,   311,   313,   314,   364,   113,   169,
     169,   131,   285,   355,   351,   345,   343,   357,    99,   335,
     323,   332,   105,   117,   120,   321,   117,   120,   243,   241,
     239,   252,   115,   124,   125,   257,   258,   321,   251,   249,
     115,   237,   235,   117,   103,   265,   362,   117,   120,   117,
     120,   120,   117,   120,   120,   113,   113,    16,   117,   166,
     207,   113,   169,   113,   149,   221,   252,   252,   165,   158,
     153,   113,   113,   317,   321,    24,   309,   269,   308,   362,
     137,   113,   113,   114,   353,   349,   323,   341,   334,   333,
     107,   294,   297,   244,   114,   241,   117,   261,   257,   259,
     260,   114,   251,   321,   114,   237,   328,   114,   359,   185,
     321,   321,   172,   173,   269,   269,   117,   251,   206,   113,
     208,   114,   140,   147,   200,   256,   114,   140,   200,   212,
     217,   219,   113,   114,   140,   163,   171,   182,   200,   204,
     209,   304,   305,   114,   121,   156,   201,   254,   358,   114,
     140,   150,   151,   200,   252,   183,   184,   114,   140,   200,
     314,   315,   117,   118,   312,   321,   269,   114,   158,   210,
     211,    82,    94,   342,   344,   352,   356,    84,    94,   342,
     344,   348,   356,   117,    93,   103,   322,   340,   105,   270,
     114,   140,   200,   245,   246,   114,   252,   261,   119,   255,
     114,   114,   323,   120,   237,   237,   269,   114,   251,   205,
     251,   113,    14,   113,   252,   181,   113,   122,   199,   113,
     115,   116,   113,   115,   241,   241,   113,   321,   312,   114,
     237,   237,   346,   113,   252,   321,   117,   114,   114,   114,
     251,   114,   148,   252,   220,   119,   179,   164,   122,   157,
     321,   115,   152,   321,   114,   114,   316,    25,   310,   321,
     114,   114,   323,   247,   253,   117,   118,   120,   329,   114,
     149,   119,   221,   214,   231,   232,   233,   252,    55,   114,
     140,   176,   177,   200,   256,   165,   158,   321,   153,   317,
     269,   310,   117,   244,   252,   321,   321,   323,   114,   120,
     114,   120,   117,   115,   113,   113,   114,   114,   114,   114,
     347,   114,     3,   120,   120,    86,   113,   119,   216,   233,
     321,   175,   178,   323,   252,   213,    15,    16,   215,   228,
     229,   230,   252,   115,   114,   174,   321,   179,    86,   224,
     225,   123,   123,   120,   117,   218,   115,   114,    17,   114,
     226,   252,   252,   228,   321,   321,    15,    91,    16,    91,
     115,    91,    92,   227,   117,    91,    92
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (&yylloc, context, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc, scanner)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location, context); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, CpgParserContext *context)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, context)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    CpgParserContext *context;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
  YYUSE (context);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, CpgParserContext *context)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp, context)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    CpgParserContext *context;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, context);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, CpgParserContext *context)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule, context)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
    CpgParserContext *context;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       , context);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule, context); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, CpgParserContext *context)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp, context)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
    CpgParserContext *context;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (context);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (CpgParserContext *context);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (CpgParserContext *context)
#else
int
yyparse (context)
    CpgParserContext *context;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[2];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 24:

/* Line 1455 of yacc.c  */
#line 263 "cpg-parser.y"
    { cpg_parser_context_push_scope (context, (yyvsp[(1) - (2)].list)); }
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 265 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 275 "cpg-parser.y"
    { cpg_parser_context_include (context, (yyvsp[(3) - (3)].string), (yyvsp[(1) - (3)].list)); errb }
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 282 "cpg-parser.y"
    { cpg_parser_context_push_scope (context, (yyvsp[(1) - (4)].list)); }
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 284 "cpg-parser.y"
    { cpg_parser_context_push_input_from_path (context, (yyvsp[(3) - (7)].string), (yyvsp[(1) - (7)].list)); errb;
	                                  cpg_parser_context_pop (context); }
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 291 "cpg-parser.y"
    { cpg_parser_context_push_network (context, (yyvsp[(1) - (3)].list)); }
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 293 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 307 "cpg-parser.y"
    { cpg_parser_context_push_string (context); }
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 309 "cpg-parser.y"
    { cpg_parser_context_push_annotation (context,
	                                                                      cpg_parser_context_pop_string (context)); }
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 314 "cpg-parser.y"
    { (yyval.num) = CPG_PARSER_CODE_EVENT_BEFORE_APPLY; }
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 315 "cpg-parser.y"
    { (yyval.num) = CPG_PARSER_CODE_EVENT_AFTER_APPLY; }
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 316 "cpg-parser.y"
    { (yyval.num) = CPG_PARSER_CODE_EVENT_BEFORE_UNAPPLY; }
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 317 "cpg-parser.y"
    { (yyval.num) = CPG_PARSER_CODE_EVENT_AFTER_UNAPPLY; }
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 322 "cpg-parser.y"
    { cpg_parser_context_apply_template (context,
					                                     (yyvsp[(2) - (4)].selector), (yyvsp[(4) - (4)].selector)); }
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 324 "cpg-parser.y"
    { cpg_parser_context_apply_template (context,
	                                                                     (yyvsp[(2) - (2)].selector), NULL); }
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 330 "cpg-parser.y"
    { cpg_parser_context_unapply_template (context,
					                                       (yyvsp[(2) - (4)].selector), (yyvsp[(4) - (4)].selector)); }
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 332 "cpg-parser.y"
    { cpg_parser_context_unapply_template (context,
					                                       (yyvsp[(2) - (2)].selector), NULL); }
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 345 "cpg-parser.y"
    { cpg_parser_context_push_scope (context, (yyvsp[(1) - (2)].list)); }
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 347 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 356 "cpg-parser.y"
    { cpg_parser_context_add_integrator_property (context, (yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].string)); }
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 363 "cpg-parser.y"
    { cpg_parser_context_push_scope (context, (yyvsp[(1) - (2)].list)); }
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 365 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 376 "cpg-parser.y"
    { cpg_parser_context_push_integrator (context, (yyvsp[(1) - (3)].list)); }
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 378 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 383 "cpg-parser.y"
    { cpg_parser_context_define (context,
					                             (yyvsp[(1) - (3)].multiassign).name,
					                             (yyvsp[(3) - (3)].string),
					                             FALSE,
					                             (yyvsp[(1) - (3)].multiassign).count,
					                             (yyvsp[(1) - (3)].multiassign).unexpanded); }
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 390 "cpg-parser.y"
    { cpg_parser_context_define (context,
					                             (yyvsp[(1) - (4)].multiassign).name,
					                             (yyvsp[(4) - (4)].string),
					                             TRUE,
					                             (yyvsp[(1) - (4)].multiassign).count,
					                             (yyvsp[(1) - (4)].multiassign).unexpanded); }
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 398 "cpg-parser.y"
    { cpg_parser_context_push_scope (context, (yyvsp[(1) - (2)].list)); }
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 400 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 411 "cpg-parser.y"
    { cpg_parser_context_push_define (context, (yyvsp[(1) - (3)].list)); }
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 413 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 419 "cpg-parser.y"
    { cpg_parser_context_push_templates (context, (yyvsp[(1) - (3)].list)); }
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 421 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 433 "cpg-parser.y"
    { cpg_parser_context_push_scope (context, (yyvsp[(1) - (2)].list)); }
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 435 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 445 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend (NULL, (yyvsp[(2) - (2)].selector)); }
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 447 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend ((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].selector)); }
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 451 "cpg-parser.y"
    { (yyval.list) = g_slist_append ((yyvsp[(3) - (3)].list), (yyvsp[(2) - (3)].selector)); }
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 452 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend (NULL, (yyvsp[(2) - (2)].selector)); }
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 456 "cpg-parser.y"
    { (yyval.list) = g_slist_reverse ((yyvsp[(1) - (1)].list)); }
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 460 "cpg-parser.y"
    { (yyval.list) = NULL; }
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 461 "cpg-parser.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 465 "cpg-parser.y"
    { (yyval.string) = NULL; }
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 466 "cpg-parser.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 474 "cpg-parser.y"
    { cpg_parser_context_push_state (context, (yyvsp[(3) - (5)].string), (yyvsp[(4) - (5)].list), (yyvsp[(1) - (5)].list)); errb }
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 476 "cpg-parser.y"
    { (yyval.list) = cpg_parser_context_pop (context); errb }
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 481 "cpg-parser.y"
    { cpg_parser_context_push_selection (context,
	                                                                     (yyvsp[(3) - (5)].selector),
	                                                                     CPG_SELECTOR_TYPE_STATE |
	                                                                     CPG_SELECTOR_TYPE_GROUP,
	                                                                     (yyvsp[(4) - (5)].list),
	                                                                     (yyvsp[(1) - (5)].list)); }
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 488 "cpg-parser.y"
    { cpg_parser_context_pop (context); errb }
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 493 "cpg-parser.y"
    { cpg_parser_context_set_input_file_setting (context, (yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].string)); }
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 513 "cpg-parser.y"
    { cpg_parser_context_push_scope (context, (yyvsp[(1) - (2)].list)); }
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 515 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 528 "cpg-parser.y"
    { cpg_parser_context_push_input_file (context, (yyvsp[(5) - (6)].string), (yyvsp[(3) - (6)].string), (yyvsp[(1) - (6)].list)); }
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 530 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 538 "cpg-parser.y"
    { cpg_parser_context_push_group (context, (yyvsp[(3) - (5)].string), (yyvsp[(4) - (5)].list), (yyvsp[(1) - (5)].list)); errb }
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 540 "cpg-parser.y"
    { cpg_parser_context_pop (context); errb }
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 545 "cpg-parser.y"
    { cpg_parser_context_push_selection (context,
	                                                                     (yyvsp[(3) - (5)].selector),
	                                                                     CPG_SELECTOR_TYPE_GROUP,
	                                                                     (yyvsp[(4) - (5)].list),
	                                                                     (yyvsp[(1) - (5)].list)); }
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 551 "cpg-parser.y"
    { cpg_parser_context_pop (context); errb }
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 555 "cpg-parser.y"
    { (yyval.object) = (yyvsp[(1) - (1)].string); }
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 556 "cpg-parser.y"
    { (yyval.object) = (yyvsp[(1) - (1)].selector); }
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 560 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend (NULL, (yyvsp[(1) - (1)].object)); }
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 563 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend ((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].object)); }
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 567 "cpg-parser.y"
    { (yyval.list) = g_slist_reverse ((yyvsp[(1) - (1)].list)); }
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 571 "cpg-parser.y"
    { (yyval.attribute) = cpg_attribute_new ("proxy"); }
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 572 "cpg-parser.y"
    { (yyval.attribute) = cpg_attribute_new ("proxy"); }
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 576 "cpg-parser.y"
    { (yyval.attribute) = cpg_attribute_new ("each"); }
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 580 "cpg-parser.y"
    { (yyval.attribute) = cpg_attribute_new ("each");
					  cpg_attribute_set_arguments ((yyval.attribute), (yyvsp[(3) - (4)].list)); }
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 585 "cpg-parser.y"
    { (yyval.attribute) = cpg_attribute_new ("bidirectional"); }
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 586 "cpg-parser.y"
    { (yyval.attribute) = cpg_attribute_new ("bidirectional"); }
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 588 "cpg-parser.y"
    { (yyval.attribute) = cpg_attribute_newv ("bidirectional", (yyvsp[(3) - (6)].string), (yyvsp[(5) - (6)].string), NULL); }
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 592 "cpg-parser.y"
    { (yyval.attribute) = cpg_attribute_new ("if"); }
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 596 "cpg-parser.y"
    { (yyval.attribute) = cpg_attribute_new ("if");
					  cpg_attribute_set_arguments ((yyval.attribute), (yyvsp[(3) - (4)].list)); }
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 601 "cpg-parser.y"
    { (yyval.attribute) = cpg_attribute_newv ("with", (yyvsp[(3) - (4)].selector), NULL); }
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 605 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend (NULL, (yyvsp[(1) - (1)].string)); }
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 606 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend ((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].string)); }
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 610 "cpg-parser.y"
    { (yyval.list) = g_slist_reverse ((yyvsp[(1) - (1)].list)); }
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 614 "cpg-parser.y"
    { (yyval.attribute) = cpg_attribute_new ("no-self"); }
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 615 "cpg-parser.y"
    { (yyval.attribute) = cpg_attribute_newv ("no-self", NULL); }
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 619 "cpg-parser.y"
    { (yyval.attribute) = cpg_attribute_newv ("probability", (yyvsp[(3) - (4)].string), NULL); }
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 623 "cpg-parser.y"
    { (yyval.attribute) = cpg_attribute_new ("tag"); }
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 624 "cpg-parser.y"
    { (yyval.attribute) = cpg_attribute_new ("tag");
	                                  cpg_attribute_set_arguments ((yyval.attribute), (yyvsp[(3) - (4)].list)); }
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 640 "cpg-parser.y"
    {(yyval.list) = g_slist_prepend (NULL, (yyvsp[(1) - (1)].attribute)); }
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 642 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend ((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].attribute)); }
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 646 "cpg-parser.y"
    { (yyval.list) = NULL; }
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 647 "cpg-parser.y"
    { (yyval.list) = NULL; }
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 648 "cpg-parser.y"
    { (yyval.list) = g_slist_reverse ((yyvsp[(2) - (3)].list)); }
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 652 "cpg-parser.y"
    { (yyval.list) = NULL; }
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 653 "cpg-parser.y"
    { (yyval.list) = g_slist_reverse ((yyvsp[(2) - (3)].list)); }
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 658 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend (NULL, GINT_TO_POINTER (0));
					  (yyval.list) = g_slist_prepend ((yyval.list), (yyvsp[(4) - (4)].selector));
					  (yyval.list) = g_slist_prepend ((yyval.list), (yyvsp[(2) - (4)].selector));
					}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 662 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend (NULL, GINT_TO_POINTER (0));
					  (yyval.list) = g_slist_prepend ((yyval.list), NULL);
					  (yyval.list) = g_slist_prepend ((yyval.list), (yyvsp[(2) - (2)].selector));
					}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 666 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend (NULL, GINT_TO_POINTER (1));
					  (yyval.list) = g_slist_prepend ((yyval.list), NULL);
					  (yyval.list) = g_slist_prepend ((yyval.list), (yyvsp[(2) - (2)].selector));
					}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 673 "cpg-parser.y"
    { (yyval.list) = NULL; }
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 674 "cpg-parser.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 683 "cpg-parser.y"
    { cpg_parser_context_push_link (context, (yyvsp[(3) - (6)].string), (yyvsp[(5) - (6)].list), (yyvsp[(1) - (6)].list), (yyvsp[(4) - (6)].list)); errb }
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 685 "cpg-parser.y"
    { cpg_parser_context_pop (context); errb }
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 690 "cpg-parser.y"
    { cpg_parser_context_push_link (context, NULL, (yyvsp[(4) - (5)].list), (yyvsp[(1) - (5)].list), (yyvsp[(3) - (5)].list)); errb }
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 692 "cpg-parser.y"
    { cpg_parser_context_pop (context); errb }
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 696 "cpg-parser.y"
    { cpg_parser_context_push_link (context, NULL, (yyvsp[(3) - (4)].list), (yyvsp[(1) - (4)].list), NULL); errb }
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 698 "cpg-parser.y"
    { cpg_parser_context_pop (context); errb }
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 703 "cpg-parser.y"
    { cpg_parser_context_push_selection (context,
	                                                                     (yyvsp[(3) - (5)].selector),
	                                                                     CPG_SELECTOR_TYPE_LINK,
	                                                                     (yyvsp[(4) - (5)].list),
	                                                                     (yyvsp[(1) - (5)].list)); }
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 709 "cpg-parser.y"
    { cpg_parser_context_pop (context); errb }
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 717 "cpg-parser.y"
    { cpg_parser_context_push_object (context,
	                                                                  (yyvsp[(3) - (5)].string),
	                                                                  (yyvsp[(4) - (5)].list),
	                                                                  (yyvsp[(1) - (5)].list)); }
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 727 "cpg-parser.y"
    { cpg_parser_context_push_selection (context,
	                                                                     (yyvsp[(3) - (5)].selector),
	                                                                     CPG_SELECTOR_TYPE_OBJECT,
	                                                                     (yyvsp[(1) - (5)].list),
	                                                                     (yyvsp[(4) - (5)].list)); }
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 733 "cpg-parser.y"
    { cpg_parser_context_pop (context); errb }
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 742 "cpg-parser.y"
    { cpg_parser_context_push_scope (context, (yyvsp[(1) - (6)].list)); }
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 744 "cpg-parser.y"
    { cpg_parser_context_add_polynomial (context, (yyvsp[(3) - (9)].string), (yyvsp[(8) - (9)].list), (yyvsp[(1) - (9)].list)); errb
	                                  cpg_parser_context_pop (context); errb }
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 749 "cpg-parser.y"
    { (yyval.list) = NULL; }
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 750 "cpg-parser.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 754 "cpg-parser.y"
    { (yyval.list) = NULL; }
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 755 "cpg-parser.y"
    {(yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 759 "cpg-parser.y"
    { (yyval.list) = NULL; }
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 761 "cpg-parser.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 771 "cpg-parser.y"
    { cpg_parser_context_push_scope (context, (yyvsp[(1) - (7)].list)); }
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 772 "cpg-parser.y"
    { cpg_parser_context_add_function (context, (yyvsp[(2) - (9)].string), (yyvsp[(9) - (9)].string), g_slist_concat ((yyvsp[(4) - (9)].list), (yyvsp[(6) - (9)].list)), (yyvsp[(1) - (9)].list)); errb
	                                  cpg_parser_context_pop (context); errb }
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 781 "cpg-parser.y"
    { cpg_parser_context_push_scope (context, (yyvsp[(1) - (2)].list)); errb }
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 783 "cpg-parser.y"
    { cpg_parser_context_pop (context); errb }
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 794 "cpg-parser.y"
    { cpg_parser_context_push_scope (context, (yyvsp[(1) - (3)].list)); errb }
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 796 "cpg-parser.y"
    { cpg_parser_context_pop (context); errb}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 800 "cpg-parser.y"
    { (yyval.list) = NULL; }
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 802 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend ((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].piece)); }
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 806 "cpg-parser.y"
    { (yyval.list) = g_slist_reverse ((yyvsp[(1) - (1)].list)); }
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 811 "cpg-parser.y"
    { (yyval.piece) = create_polynomial_piece ((yyvsp[(3) - (7)].numf), (yyvsp[(5) - (7)].numf), (yyvsp[(7) - (7)].array)); }
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 815 "cpg-parser.y"
    { append_array (NULL, gdouble, (yyvsp[(1) - (1)].numf), (yyval.array) = arret); }
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 816 "cpg-parser.y"
    { append_array (NULL, gdouble, (yyvsp[(1) - (1)].numf), (yyval.array) = arret); }
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 817 "cpg-parser.y"
    { append_array ((yyvsp[(1) - (3)].array), gdouble, (yyvsp[(3) - (3)].numf), (yyval.array) = arret); }
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 818 "cpg-parser.y"
    { append_array ((yyvsp[(1) - (3)].array), gdouble, (yyvsp[(3) - (3)].numf), (yyval.array) = arret); }
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 822 "cpg-parser.y"
    { (yyval.argument) = create_function_argument ((yyvsp[(1) - (1)].string), NULL, FALSE); }
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 823 "cpg-parser.y"
    { (yyval.argument) = create_function_argument (cpg_embedded_string_prepend_text ((yyvsp[(3) - (3)].string), "from."), NULL, FALSE); }
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 824 "cpg-parser.y"
    { (yyval.argument) = create_function_argument (cpg_embedded_string_prepend_text ((yyvsp[(3) - (3)].string), "to."), NULL, FALSE); }
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 828 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend (NULL, (yyvsp[(1) - (1)].argument)); }
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 830 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend ((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].argument)); }
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 835 "cpg-parser.y"
    { (yyval.list) = g_slist_reverse ((yyvsp[(1) - (1)].list)); }
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 839 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend (NULL, (yyvsp[(1) - (1)].argument)); }
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 841 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend ((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].argument)); }
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 845 "cpg-parser.y"
    { (yyval.list) = g_slist_reverse ((yyvsp[(1) - (1)].list)); }
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 849 "cpg-parser.y"
    { (yyval.argument) = create_function_argument ((yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].string), TRUE); }
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 850 "cpg-parser.y"
    { (yyval.argument) = create_function_argument ((yyvsp[(1) - (1)].string), NULL, TRUE); }
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 859 "cpg-parser.y"
    { cpg_parser_context_set_event_handler (context, (yyvsp[(2) - (3)].num), (yyvsp[(1) - (3)].list)); }
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 861 "cpg-parser.y"
    { cpg_parser_context_unset_event_handler (context); }
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 863 "cpg-parser.y"
    { cpg_parser_context_push_scope (context, (yyvsp[(1) - (2)].list)); }
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 865 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 882 "cpg-parser.y"
    { cpg_parser_context_set_event_handler (context, (yyvsp[(2) - (3)].num), (yyvsp[(1) - (3)].list)); }
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 884 "cpg-parser.y"
    { cpg_parser_context_unset_event_handler (context); }
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 889 "cpg-parser.y"
    { cpg_parser_context_push_scope (context, (yyvsp[(1) - (2)].list)); }
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 891 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 902 "cpg-parser.y"
    { cpg_parser_context_push_scope (context, (yyvsp[(1) - (3)].list)); }
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 904 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 918 "cpg-parser.y"
    { cpg_parser_context_add_interface (context,
	                                                            (yyvsp[(2) - (6)].string),
	                                                            (yyvsp[(6) - (6)].string),
	                                                            (yyvsp[(4) - (6)].string),
	                                                            (yyvsp[(3) - (6)].num),
	                                                            (yyvsp[(1) - (6)].list)); errb }
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 930 "cpg-parser.y"
    { cpg_parser_context_push_scope (context, (yyvsp[(1) - (2)].list)); }
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 932 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 941 "cpg-parser.y"
    { cpg_parser_context_set_event_handler (context, (yyvsp[(2) - (3)].num), (yyvsp[(1) - (3)].list)); }
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 943 "cpg-parser.y"
    { cpg_parser_context_unset_event_handler (context); }
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 946 "cpg-parser.y"
    { cpg_parser_context_push_scope (context, (yyvsp[(1) - (2)].list)); }
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 948 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 963 "cpg-parser.y"
    { (yyval.num) = FALSE; }
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 964 "cpg-parser.y"
    { (yyval.num) = TRUE; }
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 969 "cpg-parser.y"
    { (yyval.multiassign).name = (yyvsp[(1) - (5)].string); (yyval.multiassign).count = (yyvsp[(3) - (5)].string); (yyval.multiassign).unexpanded = (yyvsp[(5) - (5)].string); }
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 971 "cpg-parser.y"
    { (yyval.multiassign).name = (yyvsp[(1) - (3)].string); (yyval.multiassign).count = (yyvsp[(3) - (3)].string); (yyval.multiassign).unexpanded = NULL; }
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 972 "cpg-parser.y"
    { (yyval.multiassign).name = (yyvsp[(1) - (1)].string); (yyval.multiassign).count = NULL; (yyval.multiassign).unexpanded = NULL; }
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 976 "cpg-parser.y"
    { (yyval.string) = NULL; }
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 977 "cpg-parser.y"
    { (yyval.string) = (yyvsp[(2) - (3)].string); }
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 978 "cpg-parser.y"
    { (yyval.string) = cpg_embedded_string_new ();
	                                                cpg_embedded_string_add_text ((yyval.string), "clip(");
	                                                cpg_embedded_string_push ((yyval.string), CPG_EMBEDDED_STRING_NODE_INDIRECTION, 1);
	                                                cpg_embedded_string_add_text ((yyval.string), "0");
	                                                cpg_embedded_string_pop ((yyval.string));
	                                                cpg_embedded_string_add_text ((yyval.string), ", ");
	                                                cpg_embedded_string_add_string ((yyval.string), (yyvsp[(2) - (5)].string));
	                                                cpg_embedded_string_add_text ((yyval.string), ", ");
	                                                cpg_embedded_string_add_string ((yyval.string), (yyvsp[(4) - (5)].string));
	                                                cpg_embedded_string_add_text ((yyval.string), ")"); }
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 988 "cpg-parser.y"
    { (yyval.string) = cpg_embedded_string_new ();
	                                                cpg_embedded_string_add_text ((yyval.string), "cycle(");
	                                                cpg_embedded_string_push ((yyval.string), CPG_EMBEDDED_STRING_NODE_INDIRECTION, 1);
	                                                cpg_embedded_string_add_text ((yyval.string), "0");
	                                                cpg_embedded_string_pop ((yyval.string));
	                                                cpg_embedded_string_add_text ((yyval.string), ", ");
	                                                cpg_embedded_string_add_string ((yyval.string), (yyvsp[(2) - (5)].string));
	                                                cpg_embedded_string_add_text ((yyval.string), ", ");
	                                                cpg_embedded_string_add_string ((yyval.string), (yyvsp[(4) - (5)].string));
	                                                cpg_embedded_string_add_text ((yyval.string), ")"); }
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 1007 "cpg-parser.y"
    { cpg_parser_context_add_property (context,
					                                   (yyvsp[(2) - (6)].multiassign).name,
					                                   (yyvsp[(2) - (6)].multiassign).count,
					                                   (yyvsp[(2) - (6)].multiassign).unexpanded,
					                                   (yyvsp[(4) - (6)].string),
					                                   (yyvsp[(5) - (6)].flags).add,
					                                   (yyvsp[(5) - (6)].flags).remove,
					                                   (yyvsp[(1) - (6)].list),
					                                   (yyvsp[(3) - (6)].num),
					                                   (yyvsp[(6) - (6)].string)); errb }
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 1020 "cpg-parser.y"
    { cpg_parser_context_add_property (context,
					                                   (yyvsp[(2) - (3)].multiassign).name,
					                                   (yyvsp[(2) - (3)].multiassign).count,
					                                   (yyvsp[(2) - (3)].multiassign).unexpanded,
					                                   NULL,
					                                   (yyvsp[(3) - (3)].flags).add,
					                                   (yyvsp[(3) - (3)].flags).remove,
					                                   (yyvsp[(1) - (3)].list),
					                                   FALSE,
					                                   NULL); errb }
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 1033 "cpg-parser.y"
    { (yyval.num) = 1; }
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 1034 "cpg-parser.y"
    { (yyval.num) = 0; }
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 1035 "cpg-parser.y"
    { (yyval.num) = 1; }
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 1039 "cpg-parser.y"
    { (yyval.flags).add = 0; (yyval.flags).remove = 0; ((yyvsp[(1) - (2)].num) ? (((yyval.flags).add) = (yyvsp[(2) - (2)].num)) : (((yyval.flags).remove) = (yyvsp[(2) - (2)].num))); }
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 1041 "cpg-parser.y"
    { (yyvsp[(2) - (3)].num) ? (((yyval.flags).add) |= (yyvsp[(3) - (3)].num)) : (((yyval.flags).remove) |= (yyvsp[(3) - (3)].num)); }
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 1045 "cpg-parser.y"
    { (yyval.flags) = (yyvsp[(2) - (2)].flags); }
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 1049 "cpg-parser.y"
    { (yyval.flags).add = 0; (yyval.flags).remove = 0; }
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 1054 "cpg-parser.y"
    { (yyval.num) = CPG_PROPERTY_FLAG_IN; }
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 1055 "cpg-parser.y"
    { (yyval.num) = CPG_PROPERTY_FLAG_OUT; }
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 1056 "cpg-parser.y"
    { (yyval.num) = CPG_PROPERTY_FLAG_INTEGRATED; }
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 1057 "cpg-parser.y"
    { (yyval.num) = CPG_PROPERTY_FLAG_ONCE; }
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 1065 "cpg-parser.y"
    { cpg_parser_context_add_action (context, (yyvsp[(2) - (5)].string), (yyvsp[(5) - (5)].string), (yyvsp[(1) - (5)].list)); errb }
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 1080 "cpg-parser.y"
    { cpg_parser_context_push_selector_pseudo (context,
	                                                                           CPG_SELECTOR_PSEUDO_TYPE_CHILDREN,
	                                                                           NULL); errb }
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 1088 "cpg-parser.y"
    { cpg_selector_set_implicit_children (cpg_parser_context_peek_selector (context), TRUE); }
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 1089 "cpg-parser.y"
    { (yyval.selector) = cpg_parser_context_pop_selector (context); errb }
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 1093 "cpg-parser.y"
    { (yyval.selector) = cpg_parser_context_pop_selector (context); errb;
	                                  cpg_selector_set_implicit_children ((yyval.selector), TRUE); }
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 1099 "cpg-parser.y"
    { (yyval.selector) = (yyvsp[(1) - (1)].selector); cpg_selector_set_implicit_children ((yyvsp[(1) - (1)].selector), FALSE); }
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 1108 "cpg-parser.y"
    { cpg_parser_context_push_selector_pseudo (context,
	                                                                           CPG_SELECTOR_PSEUDO_TYPE_CHILDREN,
	                                                                           NULL); errb }
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 1116 "cpg-parser.y"
    { (yyval.selector) = (yyvsp[(1) - (1)].selector); }
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 1118 "cpg-parser.y"
    { (yyval.selector) = cpg_parser_context_pop_selector (context); errb;
					  cpg_selector_set_implicit_children ((yyval.selector), TRUE); }
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 1123 "cpg-parser.y"
    { (yyval.selector) = (yyvsp[(1) - (1)].selector); cpg_selector_set_implicit_children ((yyvsp[(1) - (1)].selector), FALSE); }
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 1132 "cpg-parser.y"
    { cpg_selector_set_implicit_children (cpg_parser_context_peek_selector (context), TRUE); }
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 1136 "cpg-parser.y"
    { cpg_parser_context_begin_selector_item (context); }
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 1137 "cpg-parser.y"
    { cpg_parser_context_push_selector_identifier (context, (yyvsp[(2) - (2)].string)); errb }
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 1141 "cpg-parser.y"
    { cpg_parser_context_push_selector_regex (context, (yyvsp[(1) - (1)].string)); errb }
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 1145 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_ROOT; }
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 1146 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_TEMPLATES_ROOT; }
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 1147 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_PARENT; }
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 1148 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_FIRST; }
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 1149 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_LAST; }
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 1150 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_STATES; }
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 1151 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_LINKS; }
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 1152 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_TEMPLATES; }
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 1153 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_COUNT; }
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 1154 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_NAME; }
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 1155 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_SELF; }
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 1156 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_FROM_SET; }
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 1157 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_TYPE; }
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 1158 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_CHILDREN; }
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 1159 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_DESCENDANTS; }
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 1160 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_UNIQUE; }
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 1161 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_ANCESTORS; }
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 1162 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_GROUPS; }
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 1163 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_IMPORTS; }
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 1164 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_OBJECTS; }
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 1165 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_PROPERTIES; }
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 1166 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_ACTIONS; }
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 1167 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_FUNCTIONS; }
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 1168 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_REVERSE; }
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 1172 "cpg-parser.y"
    { cpg_parser_context_begin_selector_item (context); }
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 1176 "cpg-parser.y"
    { cpg_parser_context_push_selector_pseudo (context, (yyvsp[(1) - (1)].num), NULL); }
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 1180 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_FROM; }
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 1181 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_TO; }
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 1182 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_HAS_TEMPLATE; }
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 1186 "cpg-parser.y"
    { cpg_parser_context_begin_selector_item (context); }
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 1190 "cpg-parser.y"
    { (yyval.string) = cpg_embedded_string_new_from_string (cpg_property_flags_to_string ((yyvsp[(1) - (1)].num), CPG_PROPERTY_FLAG_NONE)); }
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 1191 "cpg-parser.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 1195 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend (NULL, (yyvsp[(1) - (1)].string)); }
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 1197 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend ((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].string)); }
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 1201 "cpg-parser.y"
    { (yyval.list) = g_slist_reverse ((yyvsp[(1) - (1)].list)); }
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 1208 "cpg-parser.y"
    { cpg_parser_context_push_selector_pseudo (context,
	                                                                                   CPG_SELECTOR_PSEUDO_TYPE_HAS_FLAG,
	                                                                                   (yyvsp[(3) - (4)].list));}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 1214 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_SIBLINGS; }
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 1215 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_SUBSET; }
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 1216 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_DEBUG; }
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 1217 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_HAS_TAG; }
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 1221 "cpg-parser.y"
    { cpg_parser_context_begin_selector_item (context); }
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 1225 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend (NULL, (yyvsp[(1) - (1)].string)); }
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 1227 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend ((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].string)); }
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 1231 "cpg-parser.y"
    { (yyval.list) = g_slist_reverse ((yyvsp[(1) - (1)].list)); }
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 1235 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend (NULL, (yyvsp[(1) - (1)].selector)); }
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 1236 "cpg-parser.y"
    { cpg_parser_context_push_selector (context); }
    break;

  case 353:

/* Line 1455 of yacc.c  */
#line 1237 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend ((yyvsp[(1) - (4)].list), (yyvsp[(4) - (4)].selector)); }
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 1241 "cpg-parser.y"
    { (yyval.list) = g_slist_reverse ((yyvsp[(1) - (1)].list)); }
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 1245 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_IF; }
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 1246 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_REMOVE; }
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 1247 "cpg-parser.y"
    { (yyval.num) = CPG_SELECTOR_PSEUDO_TYPE_IS_EMPTY; }
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 1251 "cpg-parser.y"
    { (yyval.object) = (yyvsp[(1) - (1)].string); }
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 1252 "cpg-parser.y"
    { (yyval.object) = (yyvsp[(1) - (1)].selector);
						  cpg_parser_context_push_selector (context); }
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 1257 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend (NULL, (yyvsp[(1) - (1)].object)); }
    break;

  case 361:

/* Line 1455 of yacc.c  */
#line 1259 "cpg-parser.y"
    { (yyval.list) = g_slist_prepend ((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].object)); }
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 1263 "cpg-parser.y"
    { (yyval.list) = g_slist_reverse ((yyvsp[(1) - (1)].list)); }
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 1268 "cpg-parser.y"
    { cpg_parser_context_push_selector (context); }
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 1270 "cpg-parser.y"
    { cpg_parser_context_push_selector_pseudo (context,
						                                           (yyvsp[(1) - (5)].num),
						                                           (yyvsp[(4) - (5)].list)); }
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 1274 "cpg-parser.y"
    { cpg_parser_context_push_selector_pseudo (context,
						                                           (yyvsp[(1) - (4)].num),
						                                           (yyvsp[(3) - (4)].list)); }
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 1278 "cpg-parser.y"
    { cpg_parser_context_push_selector_pseudo (context,
						                                           (yyvsp[(1) - (3)].num),
						                                           NULL); }
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 1282 "cpg-parser.y"
    { cpg_parser_context_push_selector_pseudo (context,
						                                           (yyvsp[(1) - (1)].num),
						                                           NULL); }
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 1286 "cpg-parser.y"
    { cpg_parser_context_push_selector (context); }
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 1289 "cpg-parser.y"
    { cpg_parser_context_pop_selector (context);
						  cpg_parser_context_push_selector_pseudo (context,
						                                           (yyvsp[(1) - (5)].num),
						                                           (yyvsp[(4) - (5)].list)); }
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 1294 "cpg-parser.y"
    { cpg_parser_context_push_selector_pseudo (context,
						                                           (yyvsp[(1) - (3)].num),
						                                           NULL); }
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 1298 "cpg-parser.y"
    { cpg_parser_context_push_selector_pseudo (context,
						                                           (yyvsp[(1) - (1)].num),
						                                           NULL); }
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 1314 "cpg-parser.y"
    { cpg_parser_context_import (context, (yyvsp[(5) - (5)].string), (yyvsp[(3) - (5)].string), (yyvsp[(1) - (5)].list)); errb }
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 1320 "cpg-parser.y"
    { cpg_parser_context_push_layout (context, (yyvsp[(1) - (3)].list)); }
    break;

  case 377:

/* Line 1455 of yacc.c  */
#line 1322 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;

  case 378:

/* Line 1455 of yacc.c  */
#line 1325 "cpg-parser.y"
    { cpg_parser_context_push_layout (context, (yyvsp[(1) - (2)].list)); }
    break;

  case 379:

/* Line 1455 of yacc.c  */
#line 1326 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;

  case 380:

/* Line 1455 of yacc.c  */
#line 1330 "cpg-parser.y"
    { (yyval.num) = CPG_LAYOUT_RELATION_LEFT_OF; }
    break;

  case 381:

/* Line 1455 of yacc.c  */
#line 1331 "cpg-parser.y"
    { (yyval.num) = CPG_LAYOUT_RELATION_RIGHT_OF; }
    break;

  case 382:

/* Line 1455 of yacc.c  */
#line 1332 "cpg-parser.y"
    { (yyval.num) = CPG_LAYOUT_RELATION_ABOVE; }
    break;

  case 383:

/* Line 1455 of yacc.c  */
#line 1333 "cpg-parser.y"
    { (yyval.num) = CPG_LAYOUT_RELATION_BELOW; }
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 1337 "cpg-parser.y"
    { (yyval.num) = (yyvsp[(1) - (1)].num); }
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 1338 "cpg-parser.y"
    { (yyval.num) = (yyvsp[(1) - (2)].num) | (yyvsp[(2) - (2)].num); }
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 1342 "cpg-parser.y"
    { (yyval.selector) = NULL; }
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 1343 "cpg-parser.y"
    { (yyval.selector) = (yyvsp[(2) - (2)].selector); }
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 1349 "cpg-parser.y"
    { cpg_parser_context_add_layout (context, (yyvsp[(2) - (3)].num), (yyvsp[(1) - (3)].selector), (yyvsp[(3) - (3)].selector)); errb }
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 1351 "cpg-parser.y"
    { cpg_parser_context_add_layout (context, (yyvsp[(1) - (2)].num), NULL, (yyvsp[(2) - (2)].selector)); errb }
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 1355 "cpg-parser.y"
    { (yyval.num) = TRUE; }
    break;

  case 391:

/* Line 1455 of yacc.c  */
#line 1356 "cpg-parser.y"
    { (yyval.num) = FALSE; }
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 1365 "cpg-parser.y"
    { cpg_parser_context_add_layout_position (context, (yyvsp[(1) - (6)].selector), (yyvsp[(3) - (6)].string), (yyvsp[(5) - (6)].string), (yyvsp[(6) - (6)].selector), (yyvsp[(4) - (6)].num)); errb }
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 1370 "cpg-parser.y"
    { cpg_parser_context_add_layout_position (context, NULL, (yyvsp[(2) - (5)].string), (yyvsp[(4) - (5)].string), (yyvsp[(5) - (5)].selector), (yyvsp[(3) - (5)].num)); errb }
    break;

  case 398:

/* Line 1455 of yacc.c  */
#line 1382 "cpg-parser.y"
    { cpg_parser_context_push_scope (context, (yyvsp[(1) - (2)].list)); }
    break;

  case 399:

/* Line 1455 of yacc.c  */
#line 1384 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;

  case 402:

/* Line 1455 of yacc.c  */
#line 1393 "cpg-parser.y"
    { (yyval.string) = cpg_embedded_string_new_from_string ((yyvsp[(1) - (2)].id));
	                                  cpg_embedded_string_add_text ((yyval.string), "'"); }
    break;

  case 403:

/* Line 1455 of yacc.c  */
#line 1395 "cpg-parser.y"
    { (yyval.string) = cpg_embedded_string_new_from_string ((yyvsp[(1) - (1)].id)); }
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 1399 "cpg-parser.y"
    { (yyval.string) = cpg_embedded_string_new_from_double ((yyvsp[(1) - (1)].numf)); }
    break;

  case 405:

/* Line 1455 of yacc.c  */
#line 1403 "cpg-parser.y"
    { (yyval.string) = cpg_embedded_string_new_from_integer ((yyvsp[(1) - (1)].numf)); }
    break;

  case 418:

/* Line 1455 of yacc.c  */
#line 1422 "cpg-parser.y"
    { cpg_embedded_string_add_text (cpg_parser_context_peek_string (context), (yyvsp[(1) - (1)].id)); }
    break;

  case 419:

/* Line 1455 of yacc.c  */
#line 1423 "cpg-parser.y"
    { cpg_embedded_string_push_brace (cpg_parser_context_peek_string (context)); }
    break;

  case 420:

/* Line 1455 of yacc.c  */
#line 1424 "cpg-parser.y"
    { cpg_embedded_string_pop_brace (cpg_parser_context_peek_string (context)); }
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 1433 "cpg-parser.y"
    { cpg_parser_context_push_string (context); }
    break;

  case 424:

/* Line 1455 of yacc.c  */
#line 1435 "cpg-parser.y"
    { (yyval.string) = cpg_parser_context_pop_string (context); }
    break;

  case 425:

/* Line 1455 of yacc.c  */
#line 1439 "cpg-parser.y"
    {
						cpg_embedded_string_push (cpg_parser_context_push_string (context),
						                          CPG_EMBEDDED_STRING_NODE_CONDITION,
						                          0);

						cpg_embedded_string_push (cpg_parser_context_peek_string (context),
						                          CPG_EMBEDDED_STRING_NODE_TEXT,
						                          0);
					}
    break;

  case 426:

/* Line 1455 of yacc.c  */
#line 1448 "cpg-parser.y"
    {
						cpg_embedded_string_pop (cpg_parser_context_peek_string (context));

						cpg_embedded_string_push (cpg_parser_context_peek_string (context),
						                          CPG_EMBEDDED_STRING_NODE_TEXT,
						                          0);
					}
    break;

  case 427:

/* Line 1455 of yacc.c  */
#line 1455 "cpg-parser.y"
    {
						cpg_embedded_string_pop (cpg_parser_context_peek_string (context));

						cpg_embedded_string_push (cpg_parser_context_peek_string (context),
						                          CPG_EMBEDDED_STRING_NODE_TEXT,
						                          0);
					}
    break;

  case 428:

/* Line 1455 of yacc.c  */
#line 1463 "cpg-parser.y"
    { (yyval.string) = cpg_embedded_string_pop (cpg_embedded_string_pop (cpg_parser_context_pop_string (context))); }
    break;

  case 429:

/* Line 1455 of yacc.c  */
#line 1467 "cpg-parser.y"
    {
						cpg_embedded_string_push (cpg_parser_context_push_string (context),
						                          CPG_EMBEDDED_STRING_NODE_EQUATION,
						                          0);
					}
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 1473 "cpg-parser.y"
    { (yyval.string) = cpg_embedded_string_pop (cpg_parser_context_pop_string (context)); }
    break;

  case 434:

/* Line 1455 of yacc.c  */
#line 1488 "cpg-parser.y"
    { cpg_embedded_string_add_text (cpg_parser_context_peek_string (context),
	                                                                (yyvsp[(1) - (1)].id)); }
    break;

  case 435:

/* Line 1455 of yacc.c  */
#line 1490 "cpg-parser.y"
    { cpg_embedded_string_add_text (cpg_parser_context_peek_string (context),
	                                                                (yyvsp[(1) - (1)].id)); }
    break;

  case 438:

/* Line 1455 of yacc.c  */
#line 1497 "cpg-parser.y"
    {
						cpg_embedded_string_push (cpg_parser_context_push_string (context),
						                          CPG_EMBEDDED_STRING_NODE_INDIRECTION,
						                          (yyvsp[(1) - (1)].num));
					}
    break;

  case 439:

/* Line 1455 of yacc.c  */
#line 1503 "cpg-parser.y"
    { (yyval.string) = cpg_embedded_string_pop (cpg_parser_context_pop_string (context)); }
    break;

  case 440:

/* Line 1455 of yacc.c  */
#line 1507 "cpg-parser.y"
    { cpg_parser_context_push_string (context); cpg_parser_context_begin_selector_item (context); }
    break;

  case 441:

/* Line 1455 of yacc.c  */
#line 1509 "cpg-parser.y"
    { (yyval.string) = cpg_parser_context_pop_string (context); }
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 1514 "cpg-parser.y"
    { cpg_embedded_string_push (cpg_parser_context_peek_string (context),
	                                                            CPG_EMBEDDED_STRING_NODE_INDIRECTION,
	                                                            0);
	                                  cpg_embedded_string_add_text (cpg_parser_context_peek_string (context),
	                                                                (yyvsp[(1) - (1)].id));
	                                  cpg_embedded_string_pop (cpg_parser_context_peek_string (context)); }
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 1528 "cpg-parser.y"
    { cpg_embedded_string_push (cpg_parser_context_peek_string (context),
	                                                            CPG_EMBEDDED_STRING_NODE_EQUATION,
	                                                            0);}
    break;

  case 447:

/* Line 1455 of yacc.c  */
#line 1532 "cpg-parser.y"
    { cpg_embedded_string_pop (cpg_parser_context_peek_string (context)); }
    break;

  case 448:

/* Line 1455 of yacc.c  */
#line 1536 "cpg-parser.y"
    {
						cpg_embedded_string_push (cpg_parser_context_peek_string (context),
						                          CPG_EMBEDDED_STRING_NODE_CONDITION,
						                          0);

						cpg_embedded_string_push (cpg_parser_context_peek_string (context),
						                          CPG_EMBEDDED_STRING_NODE_TEXT,
						                          0);
					}
    break;

  case 449:

/* Line 1455 of yacc.c  */
#line 1545 "cpg-parser.y"
    {
						cpg_embedded_string_pop (cpg_parser_context_peek_string (context));

						cpg_embedded_string_push (cpg_parser_context_peek_string (context),
						                          CPG_EMBEDDED_STRING_NODE_TEXT,
						                          0);
					}
    break;

  case 450:

/* Line 1455 of yacc.c  */
#line 1552 "cpg-parser.y"
    {
						cpg_embedded_string_pop (cpg_parser_context_peek_string (context));

						cpg_embedded_string_push (cpg_parser_context_peek_string (context),
						                          CPG_EMBEDDED_STRING_NODE_TEXT,
						                          0);
					}
    break;

  case 451:

/* Line 1455 of yacc.c  */
#line 1560 "cpg-parser.y"
    { cpg_embedded_string_pop (cpg_embedded_string_pop (cpg_parser_context_peek_string (context))); }
    break;

  case 455:

/* Line 1455 of yacc.c  */
#line 1567 "cpg-parser.y"
    { cpg_embedded_string_add_text (cpg_parser_context_peek_string (context), (yyvsp[(1) - (1)].id)); }
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 1576 "cpg-parser.y"
    { cpg_embedded_string_push (cpg_parser_context_peek_string (context),
	                                                            CPG_EMBEDDED_STRING_NODE_MAP,
	                                                            0);}
    break;

  case 459:

/* Line 1455 of yacc.c  */
#line 1580 "cpg-parser.y"
    { cpg_embedded_string_pop (cpg_parser_context_peek_string (context)); }
    break;

  case 463:

/* Line 1455 of yacc.c  */
#line 1587 "cpg-parser.y"
    { cpg_embedded_string_add_text (cpg_parser_context_peek_string (context), (yyvsp[(1) - (1)].id)); }
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 1596 "cpg-parser.y"
    { cpg_embedded_string_push (cpg_parser_context_peek_string (context),
	                                                            CPG_EMBEDDED_STRING_NODE_REDUCE,
	                                                            0);}
    break;

  case 467:

/* Line 1455 of yacc.c  */
#line 1600 "cpg-parser.y"
    { cpg_embedded_string_pop (cpg_parser_context_peek_string (context)); }
    break;

  case 468:

/* Line 1455 of yacc.c  */
#line 1604 "cpg-parser.y"
    { cpg_embedded_string_push (cpg_parser_context_peek_string (context),
	                                                            CPG_EMBEDDED_STRING_NODE_INDIRECTION,
	                                                            (yyvsp[(1) - (1)].num));}
    break;

  case 469:

/* Line 1455 of yacc.c  */
#line 1608 "cpg-parser.y"
    { cpg_embedded_string_pop (cpg_parser_context_peek_string (context)); }
    break;

  case 470:

/* Line 1455 of yacc.c  */
#line 1612 "cpg-parser.y"
    { cpg_parser_context_debug_selector (context, (yyvsp[(2) - (2)].selector)); }
    break;

  case 471:

/* Line 1455 of yacc.c  */
#line 1613 "cpg-parser.y"
    { cpg_parser_context_debug_string (context, (yyvsp[(2) - (2)].string)); }
    break;

  case 472:

/* Line 1455 of yacc.c  */
#line 1614 "cpg-parser.y"
    { cpg_parser_context_debug_context (context); }
    break;

  case 473:

/* Line 1455 of yacc.c  */
#line 1618 "cpg-parser.y"
    { cpg_parser_context_delete_selector (context, (yyvsp[(1) - (1)].selector)); errb }
    break;

  case 475:

/* Line 1455 of yacc.c  */
#line 1621 "cpg-parser.y"
    { cpg_parser_context_push_scope (context, (yyvsp[(1) - (2)].list)); }
    break;

  case 476:

/* Line 1455 of yacc.c  */
#line 1623 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;

  case 480:

/* Line 1455 of yacc.c  */
#line 1637 "cpg-parser.y"
    { cpg_parser_context_push_scope (context, (yyvsp[(1) - (3)].list)); }
    break;

  case 481:

/* Line 1455 of yacc.c  */
#line 1639 "cpg-parser.y"
    { cpg_parser_context_pop (context); }
    break;



/* Line 1455 of yacc.c  */
#line 5320 "cpg-parser.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, context, YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (&yylloc, context, yymsg);
	  }
	else
	  {
	    yyerror (&yylloc, context, YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc, context);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp, context);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, context, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc, context);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp, context);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 1642 "cpg-parser.y"


static void
yyerror (YYLTYPE *locp, CpgParserContext *context, char *s)
{
	cpg_parser_context_set_error (context, s);
}

static CpgFunctionPolynomialPiece *
create_polynomial_piece (gdouble  start,
                         gdouble  end,
                         GArray  *coefficients)
{
	guint len;
	gdouble *coefs = NULL;

	len = (guint)(coefficients ? coefficients->len : 0);

	if (coefficients && len > 0)
	{
		guint i;

		coefs = g_new (gdouble, len);

		for (i = 0; i < len; ++i)
		{
			coefs[i] = g_array_index (coefficients, gdouble, i);
		}
	}

	return g_object_ref_sink (cpg_function_polynomial_piece_new (start,
	                                                             end,
	                                                             coefs,
	                                                             len));
}

static CpgFunctionArgument *
create_function_argument (CpgEmbeddedString *name,
                          CpgEmbeddedString *default_value,
                          gboolean           is_explicit)
{
	return g_object_ref_sink (cpg_function_argument_new (cpg_embedded_string_expand (name, NULL, NULL),
	                                                     default_value ? cpg_expression_new (cpg_embedded_string_expand (default_value, NULL, NULL)) : NULL,
	                                                     is_explicit));
}

